/* key-manager-store.c generated by valac 0.44.0, the Vala compiler
 * generated from key-manager-store.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2004, 2005, 2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2018 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <ui/gcr-ui.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gcr/gcr-base.h>
#include <pango/pango.h>
#include "libegg/eggtreemultidnd.h"
#include <glib/gi18n-lib.h>

#define SEAHORSE_TYPE_KEY_MANAGER_STORE (seahorse_key_manager_store_get_type ())
#define SEAHORSE_KEY_MANAGER_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore))
#define SEAHORSE_KEY_MANAGER_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStoreClass))
#define SEAHORSE_IS_KEY_MANAGER_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_KEY_MANAGER_STORE))
#define SEAHORSE_IS_KEY_MANAGER_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_KEY_MANAGER_STORE))
#define SEAHORSE_KEY_MANAGER_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStoreClass))

typedef struct _SeahorseKeyManagerStore SeahorseKeyManagerStore;
typedef struct _SeahorseKeyManagerStoreClass SeahorseKeyManagerStoreClass;
typedef struct _SeahorseKeyManagerStorePrivate SeahorseKeyManagerStorePrivate;
typedef enum  {
	SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY,
	SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL,
	SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED
} SeahorseKeyManagerStoreShowFilter;

#define SEAHORSE_KEY_MANAGER_STORE_TYPE_SHOW_FILTER (seahorse_key_manager_store_show_filter_get_type ())
enum  {
	SEAHORSE_KEY_MANAGER_STORE_0_PROPERTY,
	SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY,
	SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY,
	SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY,
	SEAHORSE_KEY_MANAGER_STORE_NUM_PROPERTIES
};
static GParamSpec* seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_NUM_PROPERTIES];
typedef enum  {
	SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT,
	SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS
} SeahorseKeyManagerStoreDragInfo;

#define SEAHORSE_KEY_MANAGER_STORE_TYPE_DRAG_INFO (seahorse_key_manager_store_drag_info_get_type ())
typedef enum  {
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_ICON,
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_MARKUP,
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL,
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_DESCRIPTION,
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS
} SeahorseKeyManagerStoreColumn;

#define SEAHORSE_KEY_MANAGER_STORE_TYPE_COLUMN (seahorse_key_manager_store_column_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	SEAHORSE_FLAG_NONE = 0,
	SEAHORSE_FLAG_IS_VALID = 0x00000001,
	SEAHORSE_FLAG_CAN_ENCRYPT = 0x00000002,
	SEAHORSE_FLAG_CAN_SIGN = 0x00000004,
	SEAHORSE_FLAG_CAN_CERTIFY = 0x00000008,
	SEAHORSE_FLAG_CAN_AUTHENTICATE = 0x00000010,
	SEAHORSE_FLAG_EXPIRED = 0x00000100,
	SEAHORSE_FLAG_REVOKED = 0x00000200,
	SEAHORSE_FLAG_DISABLED = 0x00000400,
	SEAHORSE_FLAG_TRUSTED = 0x00001000,
	SEAHORSE_FLAG_PERSONAL = 0x00002000,
	SEAHORSE_FLAG_EXPORTABLE = 0x00100000,
	SEAHORSE_FLAG_DELETABLE = 0x10000000
} SeahorseFlags;

#define SEAHORSE_TYPE_FLAGS (seahorse_flags_get_type ())
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _SeahorseKeyManagerStore {
	GcrCollectionModel parent_instance;
	SeahorseKeyManagerStorePrivate * priv;
};

struct _SeahorseKeyManagerStoreClass {
	GcrCollectionModelClass parent_class;
};

struct _SeahorseKeyManagerStorePrivate {
	gchar* drag_destination;
	GError* drag_error;
	GList* drag_objects;
	GSettings* _settings;
	gchar* _filter;
	SeahorseKeyManagerStoreShowFilter _showfilter;
};

static gint SeahorseKeyManagerStore_private_offset;
static gpointer seahorse_key_manager_store_parent_class = NULL;
static GdkAtom seahorse_key_manager_store_XDS_ATOM;
static GdkAtom seahorse_key_manager_store_XDS_ATOM = 0U;
static GdkAtom seahorse_key_manager_store_TEXT_ATOM;
static GdkAtom seahorse_key_manager_store_TEXT_ATOM = 0U;
static GcrColumn* seahorse_key_manager_store__columns;
static gint seahorse_key_manager_store__columns_length1;
static GcrColumn* seahorse_key_manager_store__columns = NULL;
static gint seahorse_key_manager_store__columns_length1 = 0;
static gint _seahorse_key_manager_store__columns_size_ = 0;

GType seahorse_key_manager_store_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseKeyManagerStore, g_object_unref)
GType seahorse_key_manager_store_show_filter_get_type (void) G_GNUC_CONST;
static void seahorse_key_manager_store_on_sort_column_changed (SeahorseKeyManagerStore* self,
                                                        GtkTreeSortable* sort);
const gchar* seahorse_key_manager_store_show_filter_to_string (SeahorseKeyManagerStoreShowFilter self);
SeahorseKeyManagerStoreShowFilter seahorse_key_manager_store_show_filter_from_string (const gchar* str);
static GType seahorse_key_manager_store_drag_info_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType seahorse_key_manager_store_column_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
#define SEAHORSE_KEY_MANAGER_STORE_XDS_FILENAME "xds.txt"
#define SEAHORSE_KEY_MANAGER_STORE_MAX_XDS_ATOM_VAL_LEN ((gsize) 4096)
SeahorseKeyManagerStore* seahorse_key_manager_store_new (GcrCollection* collection,
                                                         GtkTreeView* view,
                                                         GSettings* settings);
SeahorseKeyManagerStore* seahorse_key_manager_store_construct (GType object_type,
                                                               GcrCollection* collection,
                                                               GtkTreeView* view,
                                                               GSettings* settings);
static gboolean seahorse_key_manager_store_on_filter_visible (SeahorseKeyManagerStore* self,
                                                       GObject* obj);
static gboolean _seahorse_key_manager_store_on_filter_visible_gcr_filter_collection_func (GObject* object,
                                                                                   gpointer self);
void seahorse_key_manager_store_set_settings (SeahorseKeyManagerStore* self,
                                              GSettings* value);
static void _seahorse_key_manager_store_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                               gpointer self);
static void seahorse_key_manager_store_set_sort_to (SeahorseKeyManagerStore* self,
                                             const gchar* name);
static void seahorse_key_manager_store_drag_data_get (SeahorseKeyManagerStore* self,
                                               GtkWidget* widget,
                                               GdkDragContext* context,
                                               GtkSelectionData* selection_data,
                                               guint info,
                                               guint time);
static void _seahorse_key_manager_store_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                         GdkDragContext* context,
                                                                         GtkSelectionData* selection_data,
                                                                         guint info,
                                                                         guint time_,
                                                                         gpointer self);
static void seahorse_key_manager_store_drag_begin (SeahorseKeyManagerStore* self,
                                            GtkWidget* widget,
                                            GdkDragContext* context);
static void _seahorse_key_manager_store_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   gpointer self);
static void seahorse_key_manager_store_drag_end (SeahorseKeyManagerStore* self,
                                          GtkWidget* widget,
                                          GdkDragContext* context);
static void _seahorse_key_manager_store_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                               GdkDragContext* context,
                                                               gpointer self);
static gboolean seahorse_key_manager_store_object_contains_filtered_text (SeahorseKeyManagerStore* self,
                                                                   GObject* object,
                                                                   const gchar* text);
static gboolean seahorse_key_manager_store_apply_showfilter (SeahorseKeyManagerStore* self,
                                                      GObject* obj);
GType seahorse_flags_get_type (void) G_GNUC_CONST;
SeahorseKeyManagerStoreShowFilter seahorse_key_manager_store_get_showfilter (SeahorseKeyManagerStore* self);
const gchar* seahorse_key_manager_store_get_filter (SeahorseKeyManagerStore* self);
void seahorse_key_manager_store_refilter (SeahorseKeyManagerStore* self);
GSettings* seahorse_key_manager_store_get_settings (SeahorseKeyManagerStore* self);
static gchar* seahorse_key_manager_store_xds_get_atom_value (SeahorseKeyManagerStore* self,
                                                      GdkDragContext* context);
static gboolean seahorse_key_manager_store_xds_context_offers_target (SeahorseKeyManagerStore* self,
                                                               GdkDragContext* context,
                                                               GdkAtom target);
static gboolean seahorse_key_manager_store_xds_is_dnd_valid_context (SeahorseKeyManagerStore* self,
                                                              GdkDragContext* context);
GList* seahorse_key_manager_store_get_selected_objects (GtkTreeView* view);
static gboolean seahorse_key_manager_store_export_to_text (SeahorseKeyManagerStore* self,
                                                    GtkSelectionData* selection_data);
guint seahorse_exportable_export_to_text_wait (GList* objects,
                                               guint8** output,
                                               size_t* output_length1,
                                               GError** error);
static gboolean seahorse_key_manager_store_export_to_directory (SeahorseKeyManagerStore* self,
                                                         const gchar* directory);
gint seahorse_exportable_export_to_directory_wait (GList* objects,
                                                   const gchar* directory,
                                                   GError** error);
void seahorse_util_show_error (GtkWidget* parent,
                               const gchar* heading,
                               const gchar* message);
GObject* seahorse_key_manager_store_get_object_from_path (GtkTreeView* view,
                                                          GtkTreePath* path);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
GList* seahorse_key_manager_store_get_all_objects (SeahorseKeyManagerStore* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static gint __lambda15_ (GObject* a,
                  GObject* b);
static gint ___lambda15__gcompare_func (gconstpointer a,
                                 gconstpointer b);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
void seahorse_key_manager_store_set_selected_objects (GtkTreeView* view,
                                                      GList* objects);
GObject* seahorse_key_manager_store_get_selected_object (SeahorseKeyManagerStore* self,
                                                         GtkTreeView* view);
void seahorse_key_manager_store_set_filter (SeahorseKeyManagerStore* self,
                                            const gchar* value);
void seahorse_key_manager_store_set_showfilter (SeahorseKeyManagerStore* self,
                                                SeahorseKeyManagerStoreShowFilter value);
static GObject * seahorse_key_manager_store_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void seahorse_key_manager_store_finalize (GObject * obj);
static void _vala_seahorse_key_manager_store_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_seahorse_key_manager_store_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static const GtkTargetEntry SEAHORSE_KEY_MANAGER_STORE_store_targets[2] = {{"text/plain", (guint) 0, (guint) SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT}, {"XdndDirectSave0", (guint) 0, (guint) SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS}};

static inline gpointer
seahorse_key_manager_store_get_instance_private (SeahorseKeyManagerStore* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseKeyManagerStore_private_offset);
}

const gchar*
seahorse_key_manager_store_show_filter_to_string (SeahorseKeyManagerStoreShowFilter self)
{
	const gchar* result = NULL;
#line 36 "../common/key-manager-store.vala"
	switch (self) {
#line 36 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY:
#line 267 "key-manager-store.c"
		{
#line 38 "../common/key-manager-store.vala"
			result = "";
#line 38 "../common/key-manager-store.vala"
			return result;
#line 273 "key-manager-store.c"
		}
#line 36 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL:
#line 277 "key-manager-store.c"
		{
#line 40 "../common/key-manager-store.vala"
			result = "personal";
#line 40 "../common/key-manager-store.vala"
			return result;
#line 283 "key-manager-store.c"
		}
#line 36 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED:
#line 287 "key-manager-store.c"
		{
#line 42 "../common/key-manager-store.vala"
			result = "trusted";
#line 42 "../common/key-manager-store.vala"
			return result;
#line 293 "key-manager-store.c"
		}
		default:
		{
#line 44 "../common/key-manager-store.vala"
			g_assert_not_reached ();
#line 299 "key-manager-store.c"
		}
	}
}

SeahorseKeyManagerStoreShowFilter
seahorse_key_manager_store_show_filter_from_string (const gchar* str)
{
	SeahorseKeyManagerStoreShowFilter result = 0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 49 "../common/key-manager-store.vala"
	static GQuark _tmp1_label0 = 0;
#line 49 "../common/key-manager-store.vala"
	static GQuark _tmp1_label1 = 0;
#line 49 "../common/key-manager-store.vala"
	static GQuark _tmp1_label2 = 0;
#line 49 "../common/key-manager-store.vala"
	static GQuark _tmp1_label3 = 0;
#line 49 "../common/key-manager-store.vala"
	static GQuark _tmp1_label4 = 0;
#line 49 "../common/key-manager-store.vala"
	_tmp0_ = str;
#line 49 "../common/key-manager-store.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 49 "../common/key-manager-store.vala"
	if (((_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (NULL)))) || (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (""))))) || (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("any"))))) {
#line 49 "../common/key-manager-store.vala"
		switch (0) {
#line 328 "key-manager-store.c"
			default:
			{
#line 53 "../common/key-manager-store.vala"
				result = SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY;
#line 53 "../common/key-manager-store.vala"
				return result;
#line 335 "key-manager-store.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("personal")))) {
#line 49 "../common/key-manager-store.vala"
		switch (0) {
#line 341 "key-manager-store.c"
			default:
			{
#line 55 "../common/key-manager-store.vala"
				result = SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL;
#line 55 "../common/key-manager-store.vala"
				return result;
#line 348 "key-manager-store.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("trusted")))) {
#line 49 "../common/key-manager-store.vala"
		switch (0) {
#line 354 "key-manager-store.c"
			default:
			{
#line 57 "../common/key-manager-store.vala"
				result = SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED;
#line 57 "../common/key-manager-store.vala"
				return result;
#line 361 "key-manager-store.c"
			}
		}
	} else {
#line 49 "../common/key-manager-store.vala"
		switch (0) {
#line 367 "key-manager-store.c"
			default:
			{
#line 59 "../common/key-manager-store.vala"
				g_critical ("key-manager-store.vala:59: Got unknown ShowFilter string: %s", str);
#line 60 "../common/key-manager-store.vala"
				g_assert_not_reached ();
#line 374 "key-manager-store.c"
			}
		}
	}
}

GType
seahorse_key_manager_store_show_filter_get_type (void)
{
	static volatile gsize seahorse_key_manager_store_show_filter_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_key_manager_store_show_filter_type_id__volatile)) {
		static const GEnumValue values[] = {{SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY, "SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY", "any"}, {SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL, "SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL", "personal"}, {SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED, "SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED", "trusted"}, {0, NULL, NULL}};
		GType seahorse_key_manager_store_show_filter_type_id;
		seahorse_key_manager_store_show_filter_type_id = g_enum_register_static ("SeahorseKeyManagerStoreShowFilter", values);
		g_once_init_leave (&seahorse_key_manager_store_show_filter_type_id__volatile, seahorse_key_manager_store_show_filter_type_id);
	}
	return seahorse_key_manager_store_show_filter_type_id__volatile;
}

static GType
seahorse_key_manager_store_drag_info_get_type (void)
{
	static volatile gsize seahorse_key_manager_store_drag_info_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_key_manager_store_drag_info_type_id__volatile)) {
		static const GEnumValue values[] = {{SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT, "SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT", "text"}, {SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS, "SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS", "xds"}, {0, NULL, NULL}};
		GType seahorse_key_manager_store_drag_info_type_id;
		seahorse_key_manager_store_drag_info_type_id = g_enum_register_static ("SeahorseKeyManagerStoreDragInfo", values);
		g_once_init_leave (&seahorse_key_manager_store_drag_info_type_id__volatile, seahorse_key_manager_store_drag_info_type_id);
	}
	return seahorse_key_manager_store_drag_info_type_id__volatile;
}

static GType
seahorse_key_manager_store_column_get_type (void)
{
	static volatile gsize seahorse_key_manager_store_column_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_key_manager_store_column_type_id__volatile)) {
		static const GEnumValue values[] = {{SEAHORSE_KEY_MANAGER_STORE_COLUMN_ICON, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_ICON", "icon"}, {SEAHORSE_KEY_MANAGER_STORE_COLUMN_MARKUP, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_MARKUP", "markup"}, {SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL", "label"}, {SEAHORSE_KEY_MANAGER_STORE_COLUMN_DESCRIPTION, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_DESCRIPTION", "description"}, {SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS", "n-cols"}, {0, NULL, NULL}};
		GType seahorse_key_manager_store_column_type_id;
		seahorse_key_manager_store_column_type_id = g_enum_register_static ("SeahorseKeyManagerStoreColumn", values);
		g_once_init_leave (&seahorse_key_manager_store_column_type_id__volatile, seahorse_key_manager_store_column_type_id);
	}
	return seahorse_key_manager_store_column_type_id__volatile;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 77 "../common/key-manager-store.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 424 "key-manager-store.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 77 "../common/key-manager-store.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 432 "key-manager-store.c"
}

static gboolean
_seahorse_key_manager_store_on_filter_visible_gcr_filter_collection_func (GObject* object,
                                                                          gpointer self)
{
	gboolean result;
	result = seahorse_key_manager_store_on_filter_visible ((SeahorseKeyManagerStore*) self, object);
#line 126 "../common/key-manager-store.vala"
	return result;
#line 443 "key-manager-store.c"
}

static void
_seahorse_key_manager_store_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                          gpointer self)
{
#line 167 "../common/key-manager-store.vala"
	seahorse_key_manager_store_on_sort_column_changed ((SeahorseKeyManagerStore*) self, _sender);
#line 452 "key-manager-store.c"
}

static void
_seahorse_key_manager_store_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    GtkSelectionData* selection_data,
                                                                    guint info,
                                                                    guint time_,
                                                                    gpointer self)
{
#line 179 "../common/key-manager-store.vala"
	seahorse_key_manager_store_drag_data_get ((SeahorseKeyManagerStore*) self, _sender, context, selection_data, info, time_);
#line 465 "key-manager-store.c"
}

static void
_seahorse_key_manager_store_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              gpointer self)
{
#line 180 "../common/key-manager-store.vala"
	seahorse_key_manager_store_drag_begin ((SeahorseKeyManagerStore*) self, _sender, context);
#line 475 "key-manager-store.c"
}

static void
_seahorse_key_manager_store_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                          GdkDragContext* context,
                                                          gpointer self)
{
#line 181 "../common/key-manager-store.vala"
	seahorse_key_manager_store_drag_end ((SeahorseKeyManagerStore*) self, _sender, context);
#line 485 "key-manager-store.c"
}

SeahorseKeyManagerStore*
seahorse_key_manager_store_construct (GType object_type,
                                      GcrCollection* collection,
                                      GtkTreeView* view,
                                      GSettings* settings)
{
	SeahorseKeyManagerStore * self = NULL;
	GcrFilterCollection* _tmp0_;
	GcrFilterCollection* _tmp1_;
	GtkCellRendererPixbuf* icon_renderer = NULL;
	GtkCellRendererPixbuf* _tmp2_;
	GtkCellRendererPixbuf* _tmp3_;
	GtkCellRendererPixbuf* _tmp4_;
	GtkCellRendererPixbuf* _tmp5_;
	GtkCellRendererPixbuf* _tmp6_;
	GtkTreeViewColumn* col = NULL;
	GtkCellRendererPixbuf* _tmp7_;
	GtkTreeViewColumn* _tmp8_;
	GtkTreeViewColumn* _tmp9_;
	GtkTreeViewColumn* _tmp10_;
	GtkTreeViewColumn* _tmp11_;
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp12_;
	GtkCellRendererText* _tmp13_;
	GtkCellRendererText* _tmp14_;
	GtkCellRendererText* _tmp15_;
	GtkCellRendererText* _tmp16_;
	GtkTreeViewColumn* _tmp17_;
	GtkCellRendererText* _tmp18_;
	GtkTreeViewColumn* _tmp19_;
	GtkCellRendererText* _tmp20_;
	GtkCellRendererText* _tmp21_;
	GtkCellRendererText* _tmp22_;
	GtkCellRendererText* _tmp23_;
	GtkCellRendererText* _tmp24_;
	GtkCellRendererText* _tmp25_;
	GtkCellRendererText* _tmp26_;
	GtkCellRendererText* _tmp27_;
	GtkTreeViewColumn* _tmp28_;
	GtkCellRendererText* _tmp29_;
	GtkTreeViewColumn* _tmp30_;
	GtkCellRendererText* _tmp31_;
	GtkTreeViewColumn* _tmp32_;
	GtkTreeViewColumn* _tmp33_;
	GtkTreeViewColumn* _tmp34_;
	gchar* sort_by = NULL;
	gchar* _tmp35_;
	const gchar* _tmp36_;
#line 125 "../common/key-manager-store.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 125 "../common/key-manager-store.vala"
	self = (SeahorseKeyManagerStore*) g_object_new (object_type, NULL);
#line 126 "../common/key-manager-store.vala"
	_tmp0_ = (GcrFilterCollection*) gcr_filter_collection_new_with_callback (collection, _seahorse_key_manager_store_on_filter_visible_gcr_filter_collection_func, g_object_ref (self), g_object_unref);
#line 126 "../common/key-manager-store.vala"
	_tmp1_ = _tmp0_;
#line 126 "../common/key-manager-store.vala"
	gcr_collection_model_set_collection ((GcrCollectionModel*) self, (GcrCollection*) _tmp1_);
#line 126 "../common/key-manager-store.vala"
	_g_object_unref0 (_tmp1_);
#line 127 "../common/key-manager-store.vala"
	seahorse_key_manager_store_set_settings (self, settings);
#line 130 "../common/key-manager-store.vala"
	gtk_tree_view_set_model (view, (GtkTreeModel*) self);
#line 133 "../common/key-manager-store.vala"
	_tmp2_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 133 "../common/key-manager-store.vala"
	g_object_ref_sink (_tmp2_);
#line 133 "../common/key-manager-store.vala"
	icon_renderer = _tmp2_;
#line 134 "../common/key-manager-store.vala"
	_tmp3_ = icon_renderer;
#line 134 "../common/key-manager-store.vala"
	g_object_set (_tmp3_, "stock-size", (guint) GTK_ICON_SIZE_DND, NULL);
#line 135 "../common/key-manager-store.vala"
	_tmp4_ = icon_renderer;
#line 135 "../common/key-manager-store.vala"
	g_object_set ((GtkCellRenderer*) _tmp4_, "ypad", (guint) 12, NULL);
#line 136 "../common/key-manager-store.vala"
	_tmp5_ = icon_renderer;
#line 136 "../common/key-manager-store.vala"
	g_object_set ((GtkCellRenderer*) _tmp5_, "xpad", (guint) 12, NULL);
#line 137 "../common/key-manager-store.vala"
	_tmp6_ = icon_renderer;
#line 137 "../common/key-manager-store.vala"
	g_object_set ((GtkCellRenderer*) _tmp6_, "yalign", 0.0f, NULL);
#line 138 "../common/key-manager-store.vala"
	_tmp7_ = icon_renderer;
#line 138 "../common/key-manager-store.vala"
	_tmp8_ = gtk_tree_view_column_new_with_attributes ("", (GtkCellRenderer*) _tmp7_, "gicon", SEAHORSE_KEY_MANAGER_STORE_COLUMN_ICON, NULL, NULL);
#line 138 "../common/key-manager-store.vala"
	g_object_ref_sink (_tmp8_);
#line 138 "../common/key-manager-store.vala"
	col = _tmp8_;
#line 139 "../common/key-manager-store.vala"
	_tmp9_ = col;
#line 139 "../common/key-manager-store.vala"
	gtk_tree_view_column_set_resizable (_tmp9_, FALSE);
#line 140 "../common/key-manager-store.vala"
	_tmp10_ = col;
#line 140 "../common/key-manager-store.vala"
	gtk_tree_view_append_column (view, _tmp10_);
#line 143 "../common/key-manager-store.vala"
	_tmp11_ = gtk_tree_view_column_new ();
#line 143 "../common/key-manager-store.vala"
	g_object_ref_sink (_tmp11_);
#line 143 "../common/key-manager-store.vala"
	_g_object_unref0 (col);
#line 143 "../common/key-manager-store.vala"
	col = _tmp11_;
#line 145 "../common/key-manager-store.vala"
	_tmp12_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 145 "../common/key-manager-store.vala"
	g_object_ref_sink (_tmp12_);
#line 145 "../common/key-manager-store.vala"
	text_renderer = _tmp12_;
#line 146 "../common/key-manager-store.vala"
	_tmp13_ = text_renderer;
#line 146 "../common/key-manager-store.vala"
	g_object_set ((GtkCellRenderer*) _tmp13_, "ypad", (guint) 12, NULL);
#line 147 "../common/key-manager-store.vala"
	_tmp14_ = text_renderer;
#line 147 "../common/key-manager-store.vala"
	g_object_set ((GtkCellRenderer*) _tmp14_, "yalign", 0.0f, NULL);
#line 148 "../common/key-manager-store.vala"
	_tmp15_ = text_renderer;
#line 148 "../common/key-manager-store.vala"
	g_object_set (_tmp15_, "width-chars", 30, NULL);
#line 149 "../common/key-manager-store.vala"
	_tmp16_ = text_renderer;
#line 149 "../common/key-manager-store.vala"
	g_object_set (_tmp16_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 150 "../common/key-manager-store.vala"
	_tmp17_ = col;
#line 150 "../common/key-manager-store.vala"
	_tmp18_ = text_renderer;
#line 150 "../common/key-manager-store.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp17_, (GtkCellRenderer*) _tmp18_, TRUE);
#line 151 "../common/key-manager-store.vala"
	_tmp19_ = col;
#line 151 "../common/key-manager-store.vala"
	_tmp20_ = text_renderer;
#line 151 "../common/key-manager-store.vala"
	gtk_tree_view_column_set_attributes (_tmp19_, (GtkCellRenderer*) _tmp20_, "markup", SEAHORSE_KEY_MANAGER_STORE_COLUMN_MARKUP, NULL, NULL);
#line 153 "../common/key-manager-store.vala"
	_tmp21_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 153 "../common/key-manager-store.vala"
	g_object_ref_sink (_tmp21_);
#line 153 "../common/key-manager-store.vala"
	_g_object_unref0 (text_renderer);
#line 153 "../common/key-manager-store.vala"
	text_renderer = _tmp21_;
#line 154 "../common/key-manager-store.vala"
	_tmp22_ = text_renderer;
#line 154 "../common/key-manager-store.vala"
	g_object_set ((GtkCellRenderer*) _tmp22_, "ypad", (guint) 12, NULL);
#line 155 "../common/key-manager-store.vala"
	_tmp23_ = text_renderer;
#line 155 "../common/key-manager-store.vala"
	g_object_set ((GtkCellRenderer*) _tmp23_, "xpad", (guint) 12, NULL);
#line 156 "../common/key-manager-store.vala"
	_tmp24_ = text_renderer;
#line 156 "../common/key-manager-store.vala"
	g_object_set ((GtkCellRenderer*) _tmp24_, "yalign", 0.0f, NULL);
#line 157 "../common/key-manager-store.vala"
	_tmp25_ = text_renderer;
#line 157 "../common/key-manager-store.vala"
	g_object_set ((GtkCellRenderer*) _tmp25_, "xalign", 1.0f, NULL);
#line 158 "../common/key-manager-store.vala"
	_tmp26_ = text_renderer;
#line 158 "../common/key-manager-store.vala"
	g_object_set (_tmp26_, "scale", PANGO_SCALE_SMALL, NULL);
#line 159 "../common/key-manager-store.vala"
	_tmp27_ = text_renderer;
#line 159 "../common/key-manager-store.vala"
	g_object_set (_tmp27_, "alignment", PANGO_ALIGN_RIGHT, NULL);
#line 160 "../common/key-manager-store.vala"
	_tmp28_ = col;
#line 160 "../common/key-manager-store.vala"
	_tmp29_ = text_renderer;
#line 160 "../common/key-manager-store.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp28_, (GtkCellRenderer*) _tmp29_, FALSE);
#line 161 "../common/key-manager-store.vala"
	_tmp30_ = col;
#line 161 "../common/key-manager-store.vala"
	_tmp31_ = text_renderer;
#line 161 "../common/key-manager-store.vala"
	gtk_tree_view_column_set_attributes (_tmp30_, (GtkCellRenderer*) _tmp31_, "markup", SEAHORSE_KEY_MANAGER_STORE_COLUMN_DESCRIPTION, NULL, NULL);
#line 162 "../common/key-manager-store.vala"
	_tmp32_ = col;
#line 162 "../common/key-manager-store.vala"
	gtk_tree_view_column_set_resizable (_tmp32_, TRUE);
#line 163 "../common/key-manager-store.vala"
	_tmp33_ = col;
#line 163 "../common/key-manager-store.vala"
	gtk_tree_view_append_column (view, _tmp33_);
#line 164 "../common/key-manager-store.vala"
	_tmp34_ = col;
#line 164 "../common/key-manager-store.vala"
	gtk_tree_view_column_set_sort_column_id (_tmp34_, (gint) SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL);
#line 167 "../common/key-manager-store.vala"
	g_signal_connect_object ((GtkTreeSortable*) self, "sort-column-changed", (GCallback) _seahorse_key_manager_store_on_sort_column_changed_gtk_tree_sortable_sort_column_changed, self, 0);
#line 170 "../common/key-manager-store.vala"
	_tmp35_ = g_settings_get_string (settings, "sort-by");
#line 170 "../common/key-manager-store.vala"
	sort_by = _tmp35_;
#line 171 "../common/key-manager-store.vala"
	_tmp36_ = sort_by;
#line 171 "../common/key-manager-store.vala"
	if (_tmp36_ != NULL) {
#line 698 "key-manager-store.c"
		const gchar* _tmp37_;
#line 172 "../common/key-manager-store.vala"
		_tmp37_ = sort_by;
#line 172 "../common/key-manager-store.vala"
		seahorse_key_manager_store_set_sort_to (self, _tmp37_);
#line 704 "key-manager-store.c"
	}
#line 174 "../common/key-manager-store.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, (gint) SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL, GTK_SORT_ASCENDING);
#line 177 "../common/key-manager-store.vala"
	egg_tree_multi_drag_add_drag_support (view);
#line 179 "../common/key-manager-store.vala"
	g_signal_connect_object ((GtkWidget*) view, "drag-data-get", (GCallback) _seahorse_key_manager_store_drag_data_get_gtk_widget_drag_data_get, self, 0);
#line 180 "../common/key-manager-store.vala"
	g_signal_connect_object ((GtkWidget*) view, "drag-begin", (GCallback) _seahorse_key_manager_store_drag_begin_gtk_widget_drag_begin, self, 0);
#line 181 "../common/key-manager-store.vala"
	g_signal_connect_object ((GtkWidget*) view, "drag-end", (GCallback) _seahorse_key_manager_store_drag_end_gtk_widget_drag_end, self, 0);
#line 183 "../common/key-manager-store.vala"
	gtk_drag_source_set ((GtkWidget*) view, GDK_BUTTON1_MASK, SEAHORSE_KEY_MANAGER_STORE_store_targets, (gint) G_N_ELEMENTS (SEAHORSE_KEY_MANAGER_STORE_store_targets), GDK_ACTION_COPY);
#line 125 "../common/key-manager-store.vala"
	_g_free0 (sort_by);
#line 125 "../common/key-manager-store.vala"
	_g_object_unref0 (text_renderer);
#line 125 "../common/key-manager-store.vala"
	_g_object_unref0 (col);
#line 125 "../common/key-manager-store.vala"
	_g_object_unref0 (icon_renderer);
#line 125 "../common/key-manager-store.vala"
	return self;
#line 728 "key-manager-store.c"
}

SeahorseKeyManagerStore*
seahorse_key_manager_store_new (GcrCollection* collection,
                                GtkTreeView* view,
                                GSettings* settings)
{
#line 125 "../common/key-manager-store.vala"
	return seahorse_key_manager_store_construct (SEAHORSE_TYPE_KEY_MANAGER_STORE, collection, view, settings);
#line 738 "key-manager-store.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 757 "key-manager-store.c"
}

static gboolean
seahorse_key_manager_store_object_contains_filtered_text (SeahorseKeyManagerStore* self,
                                                          GObject* object,
                                                          const gchar* text)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar* name = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GObjectClass* _tmp7_;
	GParamSpec* _tmp8_;
#line 191 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 193 "../common/key-manager-store.vala"
	if (text == NULL) {
#line 193 "../common/key-manager-store.vala"
		_tmp0_ = TRUE;
#line 779 "key-manager-store.c"
	} else {
#line 193 "../common/key-manager-store.vala"
		_tmp0_ = g_strcmp0 (text, "") == 0;
#line 783 "key-manager-store.c"
	}
#line 193 "../common/key-manager-store.vala"
	if (_tmp0_) {
#line 194 "../common/key-manager-store.vala"
		result = TRUE;
#line 194 "../common/key-manager-store.vala"
		return result;
#line 791 "key-manager-store.c"
	}
#line 196 "../common/key-manager-store.vala"
	name = NULL;
#line 197 "../common/key-manager-store.vala"
	g_object_get (object, "label", &_tmp1_, NULL, NULL);
#line 197 "../common/key-manager-store.vala"
	_g_free0 (name);
#line 197 "../common/key-manager-store.vala"
	name = _tmp1_;
#line 198 "../common/key-manager-store.vala"
	_tmp3_ = name;
#line 198 "../common/key-manager-store.vala"
	if (_tmp3_ != NULL) {
#line 805 "key-manager-store.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 198 "../common/key-manager-store.vala"
		_tmp4_ = name;
#line 198 "../common/key-manager-store.vala"
		_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 198 "../common/key-manager-store.vala"
		_tmp6_ = _tmp5_;
#line 198 "../common/key-manager-store.vala"
		_tmp2_ = string_contains (_tmp6_, text);
#line 198 "../common/key-manager-store.vala"
		_g_free0 (_tmp6_);
#line 819 "key-manager-store.c"
	} else {
#line 198 "../common/key-manager-store.vala"
		_tmp2_ = FALSE;
#line 823 "key-manager-store.c"
	}
#line 198 "../common/key-manager-store.vala"
	if (_tmp2_) {
#line 199 "../common/key-manager-store.vala"
		result = TRUE;
#line 199 "../common/key-manager-store.vala"
		_g_free0 (name);
#line 199 "../common/key-manager-store.vala"
		return result;
#line 833 "key-manager-store.c"
	}
#line 201 "../common/key-manager-store.vala"
	_tmp7_ = G_OBJECT_GET_CLASS (object);
#line 201 "../common/key-manager-store.vala"
	_tmp8_ = g_object_class_find_property (_tmp7_, "description");
#line 201 "../common/key-manager-store.vala"
	if (_tmp8_ != NULL) {
#line 841 "key-manager-store.c"
		gchar* description = NULL;
		gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
#line 202 "../common/key-manager-store.vala"
		description = NULL;
#line 203 "../common/key-manager-store.vala"
		g_object_get (object, "description", &_tmp9_, NULL, NULL);
#line 203 "../common/key-manager-store.vala"
		_g_free0 (description);
#line 203 "../common/key-manager-store.vala"
		description = _tmp9_;
#line 204 "../common/key-manager-store.vala"
		_tmp11_ = description;
#line 204 "../common/key-manager-store.vala"
		if (_tmp11_ != NULL) {
#line 858 "key-manager-store.c"
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 204 "../common/key-manager-store.vala"
			_tmp12_ = description;
#line 204 "../common/key-manager-store.vala"
			_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) -1);
#line 204 "../common/key-manager-store.vala"
			_tmp14_ = _tmp13_;
#line 204 "../common/key-manager-store.vala"
			_tmp10_ = string_contains (_tmp14_, text);
#line 204 "../common/key-manager-store.vala"
			_g_free0 (_tmp14_);
#line 872 "key-manager-store.c"
		} else {
#line 204 "../common/key-manager-store.vala"
			_tmp10_ = FALSE;
#line 876 "key-manager-store.c"
		}
#line 204 "../common/key-manager-store.vala"
		if (_tmp10_) {
#line 205 "../common/key-manager-store.vala"
			result = TRUE;
#line 205 "../common/key-manager-store.vala"
			_g_free0 (description);
#line 205 "../common/key-manager-store.vala"
			_g_free0 (name);
#line 205 "../common/key-manager-store.vala"
			return result;
#line 888 "key-manager-store.c"
		}
#line 201 "../common/key-manager-store.vala"
		_g_free0 (description);
#line 892 "key-manager-store.c"
	}
#line 208 "../common/key-manager-store.vala"
	result = FALSE;
#line 208 "../common/key-manager-store.vala"
	_g_free0 (name);
#line 208 "../common/key-manager-store.vala"
	return result;
#line 900 "key-manager-store.c"
}

static gboolean
seahorse_key_manager_store_apply_showfilter (SeahorseKeyManagerStore* self,
                                             GObject* obj)
{
	gboolean result = FALSE;
	SeahorseFlags obj_flags = 0;
	SeahorseFlags _tmp0_ = 0;
	SeahorseKeyManagerStoreShowFilter _tmp1_;
#line 211 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 212 "../common/key-manager-store.vala"
	obj_flags = SEAHORSE_FLAG_NONE;
#line 213 "../common/key-manager-store.vala"
	g_object_get (obj, "object-flags", &_tmp0_, NULL, NULL);
#line 213 "../common/key-manager-store.vala"
	obj_flags = _tmp0_;
#line 215 "../common/key-manager-store.vala"
	_tmp1_ = self->priv->_showfilter;
#line 215 "../common/key-manager-store.vala"
	switch (_tmp1_) {
#line 215 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL:
#line 925 "key-manager-store.c"
		{
			SeahorseFlags _tmp2_;
#line 217 "../common/key-manager-store.vala"
			_tmp2_ = obj_flags;
#line 217 "../common/key-manager-store.vala"
			result = (_tmp2_ & SEAHORSE_FLAG_PERSONAL) == SEAHORSE_FLAG_PERSONAL;
#line 217 "../common/key-manager-store.vala"
			return result;
#line 934 "key-manager-store.c"
		}
#line 215 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED:
#line 938 "key-manager-store.c"
		{
			SeahorseFlags _tmp3_;
#line 219 "../common/key-manager-store.vala"
			_tmp3_ = obj_flags;
#line 219 "../common/key-manager-store.vala"
			result = (_tmp3_ & SEAHORSE_FLAG_TRUSTED) == SEAHORSE_FLAG_TRUSTED;
#line 219 "../common/key-manager-store.vala"
			return result;
#line 947 "key-manager-store.c"
		}
#line 215 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY:
#line 951 "key-manager-store.c"
		{
#line 221 "../common/key-manager-store.vala"
			result = TRUE;
#line 221 "../common/key-manager-store.vala"
			return result;
#line 957 "key-manager-store.c"
		}
		default:
#line 215 "../common/key-manager-store.vala"
		break;
#line 962 "key-manager-store.c"
	}
#line 224 "../common/key-manager-store.vala"
	result = FALSE;
#line 224 "../common/key-manager-store.vala"
	return result;
#line 968 "key-manager-store.c"
}

static gboolean
seahorse_key_manager_store_on_filter_visible (SeahorseKeyManagerStore* self,
                                              GObject* obj)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 228 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 229 "../common/key-manager-store.vala"
	if (seahorse_key_manager_store_apply_showfilter (self, obj)) {
#line 981 "key-manager-store.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 230 "../common/key-manager-store.vala"
		_tmp1_ = seahorse_key_manager_store_get_filter (self);
#line 230 "../common/key-manager-store.vala"
		_tmp2_ = _tmp1_;
#line 230 "../common/key-manager-store.vala"
		_tmp0_ = seahorse_key_manager_store_object_contains_filtered_text (self, obj, _tmp2_);
#line 990 "key-manager-store.c"
	} else {
#line 229 "../common/key-manager-store.vala"
		_tmp0_ = FALSE;
#line 994 "key-manager-store.c"
	}
#line 229 "../common/key-manager-store.vala"
	result = _tmp0_;
#line 229 "../common/key-manager-store.vala"
	return result;
#line 1000 "key-manager-store.c"
}

void
seahorse_key_manager_store_refilter (SeahorseKeyManagerStore* self)
{
	GcrFilterCollection* collection = NULL;
	GcrCollection* _tmp0_;
	GcrCollection* _tmp1_;
	GcrCollection* _tmp2_;
#line 233 "../common/key-manager-store.vala"
	g_return_if_fail (self != NULL);
#line 234 "../common/key-manager-store.vala"
	_tmp0_ = gcr_collection_model_get_collection ((GcrCollectionModel*) self);
#line 234 "../common/key-manager-store.vala"
	_tmp1_ = _tmp0_;
#line 234 "../common/key-manager-store.vala"
	collection = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gcr_filter_collection_get_type (), GcrFilterCollection);
#line 235 "../common/key-manager-store.vala"
	gcr_filter_collection_refilter (collection);
#line 236 "../common/key-manager-store.vala"
	_tmp2_ = gcr_filter_collection_get_underlying (collection);
#line 236 "../common/key-manager-store.vala"
	g_debug ("key-manager-store.vala:236: %u/%u elements visible after refilter", gcr_collection_get_length ((GcrCollection*) collection), gcr_collection_get_length (_tmp2_));
#line 1024 "key-manager-store.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 1041 "key-manager-store.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "glib-2.0.vapi"
		result = maxlen;
#line 1394 "glib-2.0.vapi"
		return result;
#line 1064 "key-manager-store.c"
	} else {
		gchar* _tmp2_;
#line 1396 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "glib-2.0.vapi"
		return result;
#line 1073 "key-manager-store.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1403 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1092 "key-manager-store.c"
	} else {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1096 "key-manager-store.c"
	}
#line 1405 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1102 "key-manager-store.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1112 "key-manager-store.c"
	}
#line 1412 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1413 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1414 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1120 "key-manager-store.c"
	} else {
#line 1416 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1124 "key-manager-store.c"
	}
#line 1418 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1419 "glib-2.0.vapi"
		len = string_length - offset;
#line 1130 "key-manager-store.c"
	}
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "glib-2.0.vapi"
	result = _tmp3_;
#line 1422 "glib-2.0.vapi"
	return result;
#line 1140 "key-manager-store.c"
}

static void
seahorse_key_manager_store_set_sort_to (SeahorseKeyManagerStore* self,
                                        const gchar* name)
{
	GtkSortType _tmp0_ = 0;
	GtkSortType ord = 0;
	gchar* without_sign = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gint id = 0;
#line 241 "../common/key-manager-store.vala"
	g_return_if_fail (self != NULL);
#line 241 "../common/key-manager-store.vala"
	g_return_if_fail (name != NULL);
#line 243 "../common/key-manager-store.vala"
	if (string_get (name, (glong) 0) == '-') {
#line 243 "../common/key-manager-store.vala"
		_tmp0_ = GTK_SORT_DESCENDING;
#line 1161 "key-manager-store.c"
	} else {
#line 243 "../common/key-manager-store.vala"
		_tmp0_ = GTK_SORT_ASCENDING;
#line 1165 "key-manager-store.c"
	}
#line 243 "../common/key-manager-store.vala"
	ord = _tmp0_;
#line 245 "../common/key-manager-store.vala"
	_tmp1_ = g_strdup (name);
#line 245 "../common/key-manager-store.vala"
	without_sign = _tmp1_;
#line 246 "../common/key-manager-store.vala"
	if (string_get (name, (glong) 0) == '-') {
#line 246 "../common/key-manager-store.vala"
		_tmp2_ = TRUE;
#line 1177 "key-manager-store.c"
	} else {
#line 246 "../common/key-manager-store.vala"
		_tmp2_ = string_get (name, (glong) 0) == '+';
#line 1181 "key-manager-store.c"
	}
#line 246 "../common/key-manager-store.vala"
	if (_tmp2_) {
#line 1185 "key-manager-store.c"
		gchar* _tmp3_;
#line 247 "../common/key-manager-store.vala"
		_tmp3_ = string_substring (name, (glong) 1, (glong) -1);
#line 247 "../common/key-manager-store.vala"
		_g_free0 (without_sign);
#line 247 "../common/key-manager-store.vala"
		without_sign = _tmp3_;
#line 1193 "key-manager-store.c"
	}
#line 250 "../common/key-manager-store.vala"
	id = -1;
#line 1197 "key-manager-store.c"
	{
		gint i = 0;
#line 251 "../common/key-manager-store.vala"
		i = (gint) (SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS - 1);
#line 1202 "key-manager-store.c"
		{
			gboolean _tmp4_ = FALSE;
#line 251 "../common/key-manager-store.vala"
			_tmp4_ = TRUE;
#line 251 "../common/key-manager-store.vala"
			while (TRUE) {
#line 1209 "key-manager-store.c"
				gchar* n = NULL;
				GcrColumn* _tmp6_;
				gint _tmp6__length1;
				GcrColumn _tmp7_;
				void* _tmp8_;
				gchar* _tmp9_;
				gboolean _tmp10_ = FALSE;
				const gchar* _tmp11_;
#line 251 "../common/key-manager-store.vala"
				if (!_tmp4_) {
#line 1220 "key-manager-store.c"
					gint _tmp5_;
#line 251 "../common/key-manager-store.vala"
					_tmp5_ = i;
#line 251 "../common/key-manager-store.vala"
					i = _tmp5_ - 1;
#line 1226 "key-manager-store.c"
				}
#line 251 "../common/key-manager-store.vala"
				_tmp4_ = FALSE;
#line 251 "../common/key-manager-store.vala"
				if (!(i >= 0)) {
#line 251 "../common/key-manager-store.vala"
					break;
#line 1234 "key-manager-store.c"
				}
#line 252 "../common/key-manager-store.vala"
				_tmp6_ = seahorse_key_manager_store__columns;
#line 252 "../common/key-manager-store.vala"
				_tmp6__length1 = seahorse_key_manager_store__columns_length1;
#line 252 "../common/key-manager-store.vala"
				_tmp7_ = _tmp6_[i];
#line 252 "../common/key-manager-store.vala"
				_tmp8_ = _tmp7_.user_data;
#line 252 "../common/key-manager-store.vala"
				_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 252 "../common/key-manager-store.vala"
				n = _tmp9_;
#line 253 "../common/key-manager-store.vala"
				_tmp11_ = n;
#line 253 "../common/key-manager-store.vala"
				if (_tmp11_ != NULL) {
#line 1252 "key-manager-store.c"
					const gchar* _tmp12_;
#line 253 "../common/key-manager-store.vala"
					_tmp12_ = n;
#line 253 "../common/key-manager-store.vala"
					_tmp10_ = g_strcmp0 (name, _tmp12_) == 0;
#line 1258 "key-manager-store.c"
				} else {
#line 253 "../common/key-manager-store.vala"
					_tmp10_ = FALSE;
#line 1262 "key-manager-store.c"
				}
#line 253 "../common/key-manager-store.vala"
				if (_tmp10_) {
#line 254 "../common/key-manager-store.vala"
					id = i;
#line 255 "../common/key-manager-store.vala"
					_g_free0 (n);
#line 255 "../common/key-manager-store.vala"
					break;
#line 1272 "key-manager-store.c"
				}
#line 251 "../common/key-manager-store.vala"
				_g_free0 (n);
#line 1276 "key-manager-store.c"
			}
		}
	}
#line 259 "../common/key-manager-store.vala"
	if (id != -1) {
#line 1282 "key-manager-store.c"
		GtkSortType _tmp13_;
#line 260 "../common/key-manager-store.vala"
		_tmp13_ = ord;
#line 260 "../common/key-manager-store.vala"
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, id, _tmp13_);
#line 1288 "key-manager-store.c"
	}
#line 241 "../common/key-manager-store.vala"
	_g_free0 (without_sign);
#line 1292 "key-manager-store.c"
}

static void
seahorse_key_manager_store_on_sort_column_changed (SeahorseKeyManagerStore* self,
                                                   GtkTreeSortable* sort)
{
	GSettings* _tmp0_;
	gint column_id = 0;
	GtkSortType ord = 0;
	gint _tmp1_ = 0;
	GtkSortType _tmp2_ = 0;
	gboolean _tmp3_;
#line 264 "../common/key-manager-store.vala"
	g_return_if_fail (self != NULL);
#line 264 "../common/key-manager-store.vala"
	g_return_if_fail (sort != NULL);
#line 265 "../common/key-manager-store.vala"
	_tmp0_ = self->priv->_settings;
#line 265 "../common/key-manager-store.vala"
	if (_tmp0_ == NULL) {
#line 266 "../common/key-manager-store.vala"
		return;
#line 1315 "key-manager-store.c"
	}
#line 271 "../common/key-manager-store.vala"
	_tmp3_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) self, &_tmp1_, &_tmp2_);
#line 271 "../common/key-manager-store.vala"
	column_id = _tmp1_;
#line 271 "../common/key-manager-store.vala"
	ord = _tmp2_;
#line 271 "../common/key-manager-store.vala"
	if (_tmp3_) {
#line 1325 "key-manager-store.c"
		gboolean _tmp4_ = FALSE;
#line 272 "../common/key-manager-store.vala"
		if (column_id >= 0) {
#line 272 "../common/key-manager-store.vala"
			_tmp4_ = column_id < ((gint) SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS);
#line 1331 "key-manager-store.c"
		} else {
#line 272 "../common/key-manager-store.vala"
			_tmp4_ = FALSE;
#line 1335 "key-manager-store.c"
		}
#line 272 "../common/key-manager-store.vala"
		if (_tmp4_) {
#line 1339 "key-manager-store.c"
			GcrColumn* _tmp5_;
			gint _tmp5__length1;
			GcrColumn _tmp6_;
			void* _tmp7_;
#line 273 "../common/key-manager-store.vala"
			_tmp5_ = seahorse_key_manager_store__columns;
#line 273 "../common/key-manager-store.vala"
			_tmp5__length1 = seahorse_key_manager_store__columns_length1;
#line 273 "../common/key-manager-store.vala"
			_tmp6_ = _tmp5_[column_id];
#line 273 "../common/key-manager-store.vala"
			_tmp7_ = _tmp6_.user_data;
#line 273 "../common/key-manager-store.vala"
			if (_tmp7_ != NULL) {
#line 1354 "key-manager-store.c"
				const gchar* _tmp8_ = NULL;
				GtkSortType _tmp9_;
				gchar* sign = NULL;
				gchar* _tmp10_;
				GSettings* _tmp11_;
				const gchar* _tmp12_;
				GcrColumn* _tmp13_;
				gint _tmp13__length1;
				GcrColumn _tmp14_;
				void* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
#line 274 "../common/key-manager-store.vala"
				_tmp9_ = ord;
#line 274 "../common/key-manager-store.vala"
				if (_tmp9_ == GTK_SORT_DESCENDING) {
#line 274 "../common/key-manager-store.vala"
					_tmp8_ = "-";
#line 1373 "key-manager-store.c"
				} else {
#line 274 "../common/key-manager-store.vala"
					_tmp8_ = "";
#line 1377 "key-manager-store.c"
				}
#line 274 "../common/key-manager-store.vala"
				_tmp10_ = g_strdup (_tmp8_);
#line 274 "../common/key-manager-store.vala"
				sign = _tmp10_;
#line 275 "../common/key-manager-store.vala"
				_tmp11_ = self->priv->_settings;
#line 275 "../common/key-manager-store.vala"
				_tmp12_ = sign;
#line 275 "../common/key-manager-store.vala"
				_tmp13_ = seahorse_key_manager_store__columns;
#line 275 "../common/key-manager-store.vala"
				_tmp13__length1 = seahorse_key_manager_store__columns_length1;
#line 275 "../common/key-manager-store.vala"
				_tmp14_ = _tmp13_[column_id];
#line 275 "../common/key-manager-store.vala"
				_tmp15_ = _tmp14_.user_data;
#line 275 "../common/key-manager-store.vala"
				_tmp16_ = g_strconcat (_tmp12_, (const gchar*) _tmp15_, NULL);
#line 275 "../common/key-manager-store.vala"
				_tmp17_ = _tmp16_;
#line 275 "../common/key-manager-store.vala"
				g_settings_set_string (_tmp11_, "sort-by", _tmp17_);
#line 275 "../common/key-manager-store.vala"
				_g_free0 (_tmp17_);
#line 273 "../common/key-manager-store.vala"
				_g_free0 (sign);
#line 1405 "key-manager-store.c"
			}
		}
	} else {
		GSettings* _tmp18_;
#line 280 "../common/key-manager-store.vala"
		_tmp18_ = self->priv->_settings;
#line 280 "../common/key-manager-store.vala"
		if (_tmp18_ != NULL) {
#line 1414 "key-manager-store.c"
			GSettings* _tmp19_;
#line 281 "../common/key-manager-store.vala"
			_tmp19_ = self->priv->_settings;
#line 281 "../common/key-manager-store.vala"
			g_settings_set_string (_tmp19_, "sort-by", "");
#line 1420 "key-manager-store.c"
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 294 "../common/key-manager-store.vala"
	return self ? g_object_ref (self) : NULL;
#line 1430 "key-manager-store.c"
}

static gchar*
seahorse_key_manager_store_xds_get_atom_value (SeahorseKeyManagerStore* self,
                                               GdkDragContext* context)
{
	gchar* result = NULL;
	GdkWindow* source_window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	guint8* ret = NULL;
	gint ret_length1 = 0;
	gint _ret_size_ = 0;
	gint len = 0;
	GdkWindow* _tmp2_;
	gint _tmp3_ = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
#line 290 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 291 "../common/key-manager-store.vala"
	if (context == NULL) {
#line 292 "../common/key-manager-store.vala"
		result = NULL;
#line 292 "../common/key-manager-store.vala"
		return result;
#line 1458 "key-manager-store.c"
	}
#line 294 "../common/key-manager-store.vala"
	_tmp0_ = gdk_drag_context_get_source_window (context);
#line 294 "../common/key-manager-store.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 294 "../common/key-manager-store.vala"
	source_window = _tmp1_;
#line 298 "../common/key-manager-store.vala"
	_tmp2_ = source_window;
#line 298 "../common/key-manager-store.vala"
	_tmp6_ = gdk_property_get (_tmp2_, seahorse_key_manager_store_XDS_ATOM, seahorse_key_manager_store_TEXT_ATOM, (gulong) 0, (gulong) SEAHORSE_KEY_MANAGER_STORE_MAX_XDS_ATOM_VAL_LEN, 0, NULL, &_tmp3_, &_tmp5_, &_tmp4_);
#line 298 "../common/key-manager-store.vala"
	len = _tmp3_;
#line 298 "../common/key-manager-store.vala"
	ret = (g_free (ret), NULL);
#line 298 "../common/key-manager-store.vala"
	ret = _tmp4_;
#line 298 "../common/key-manager-store.vala"
	ret_length1 = _tmp5_;
#line 298 "../common/key-manager-store.vala"
	_ret_size_ = ret_length1;
#line 298 "../common/key-manager-store.vala"
	if (_tmp6_) {
#line 1482 "key-manager-store.c"
		guint8* _tmp7_;
		gint _tmp7__length1;
		guint8* _tmp8_;
		gint _tmp8__length1;
		gchar* _tmp9_;
#line 300 "../common/key-manager-store.vala"
		_tmp7_ = ret;
#line 300 "../common/key-manager-store.vala"
		_tmp7__length1 = ret_length1;
#line 300 "../common/key-manager-store.vala"
		_tmp7_[len] = (guint8) '\0';
#line 301 "../common/key-manager-store.vala"
		_tmp8_ = ret;
#line 301 "../common/key-manager-store.vala"
		_tmp8__length1 = ret_length1;
#line 301 "../common/key-manager-store.vala"
		_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 301 "../common/key-manager-store.vala"
		result = _tmp9_;
#line 301 "../common/key-manager-store.vala"
		ret = (g_free (ret), NULL);
#line 301 "../common/key-manager-store.vala"
		_g_object_unref0 (source_window);
#line 301 "../common/key-manager-store.vala"
		return result;
#line 1508 "key-manager-store.c"
	}
#line 304 "../common/key-manager-store.vala"
	result = NULL;
#line 304 "../common/key-manager-store.vala"
	ret = (g_free (ret), NULL);
#line 304 "../common/key-manager-store.vala"
	_g_object_unref0 (source_window);
#line 304 "../common/key-manager-store.vala"
	return result;
#line 1518 "key-manager-store.c"
}

static gboolean
seahorse_key_manager_store_xds_context_offers_target (SeahorseKeyManagerStore* self,
                                                      GdkDragContext* context,
                                                      GdkAtom target)
{
	gboolean result = FALSE;
	GList* _tmp0_;
	GList* _tmp1_;
#line 307 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 308 "../common/key-manager-store.vala"
	_tmp0_ = gdk_drag_context_list_targets (context);
#line 308 "../common/key-manager-store.vala"
	_tmp1_ = g_list_find (_tmp0_, (gpointer) ((guintptr) target));
#line 308 "../common/key-manager-store.vala"
	result = _tmp1_ != NULL;
#line 308 "../common/key-manager-store.vala"
	return result;
#line 1539 "key-manager-store.c"
}

static gboolean
seahorse_key_manager_store_xds_is_dnd_valid_context (SeahorseKeyManagerStore* self,
                                                     GdkDragContext* context)
{
	gboolean result = FALSE;
	gchar* tmp = NULL;
	const gchar* _tmp1_;
#line 311 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 312 "../common/key-manager-store.vala"
	if (context == NULL) {
#line 313 "../common/key-manager-store.vala"
		result = FALSE;
#line 313 "../common/key-manager-store.vala"
		return result;
#line 1557 "key-manager-store.c"
	}
#line 315 "../common/key-manager-store.vala"
	tmp = NULL;
#line 316 "../common/key-manager-store.vala"
	if (seahorse_key_manager_store_xds_context_offers_target (self, context, seahorse_key_manager_store_XDS_ATOM)) {
#line 1563 "key-manager-store.c"
		gchar* _tmp0_;
#line 317 "../common/key-manager-store.vala"
		_tmp0_ = seahorse_key_manager_store_xds_get_atom_value (self, context);
#line 317 "../common/key-manager-store.vala"
		_g_free0 (tmp);
#line 317 "../common/key-manager-store.vala"
		tmp = _tmp0_;
#line 1571 "key-manager-store.c"
	}
#line 319 "../common/key-manager-store.vala"
	_tmp1_ = tmp;
#line 319 "../common/key-manager-store.vala"
	result = _tmp1_ != NULL;
#line 319 "../common/key-manager-store.vala"
	_g_free0 (tmp);
#line 319 "../common/key-manager-store.vala"
	return result;
#line 1581 "key-manager-store.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1499 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1499 "glib-2.0.vapi"
	res_length1 = -1;
#line 1499 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1500 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1500 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1500 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1501 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1501 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1501 "glib-2.0.vapi"
	_tmp3_ = _tmp2_;
#line 1501 "glib-2.0.vapi"
	_tmp3__length1 = _tmp2__length1;
#line 1501 "glib-2.0.vapi"
	if (result_length1) {
#line 1501 "glib-2.0.vapi"
		*result_length1 = _tmp3__length1;
#line 1624 "key-manager-store.c"
	}
#line 1501 "glib-2.0.vapi"
	result = _tmp3_;
#line 1501 "glib-2.0.vapi"
	return result;
#line 1630 "key-manager-store.c"
}

static void
seahorse_key_manager_store_drag_begin (SeahorseKeyManagerStore* self,
                                       GtkWidget* widget,
                                       GdkDragContext* context)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 322 "../common/key-manager-store.vala"
	g_return_if_fail (self != NULL);
#line 322 "../common/key-manager-store.vala"
	g_return_if_fail (widget != NULL);
#line 322 "../common/key-manager-store.vala"
	g_return_if_fail (context != NULL);
#line 323 "../common/key-manager-store.vala"
	g_debug ("key-manager-store.vala:323: drag_begin -.");
#line 325 "../common/key-manager-store.vala"
	_g_free0 (self->priv->drag_destination);
#line 325 "../common/key-manager-store.vala"
	self->priv->drag_destination = NULL;
#line 326 "../common/key-manager-store.vala"
	_g_error_free0 (self->priv->drag_error);
#line 326 "../common/key-manager-store.vala"
	self->priv->drag_error = NULL;
#line 327 "../common/key-manager-store.vala"
	(self->priv->drag_objects == NULL) ? NULL : (self->priv->drag_objects = (_g_list_free__g_object_unref0_ (self->priv->drag_objects), NULL));
#line 327 "../common/key-manager-store.vala"
	self->priv->drag_objects = NULL;
#line 329 "../common/key-manager-store.vala"
	_tmp0_ = seahorse_key_manager_store_get_selected_objects (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_tree_view_get_type (), GtkTreeView));
#line 329 "../common/key-manager-store.vala"
	(self->priv->drag_objects == NULL) ? NULL : (self->priv->drag_objects = (_g_list_free__g_object_unref0_ (self->priv->drag_objects), NULL));
#line 329 "../common/key-manager-store.vala"
	self->priv->drag_objects = _tmp0_;
#line 331 "../common/key-manager-store.vala"
	_tmp1_ = self->priv->drag_objects;
#line 331 "../common/key-manager-store.vala"
	if (_tmp1_ != NULL) {
#line 1670 "key-manager-store.c"
		GdkWindow* source_window = NULL;
		GdkWindow* _tmp2_;
		GdkWindow* _tmp3_;
		GdkWindow* _tmp4_;
		guint8* _tmp5_;
		gint _tmp5__length1;
		guint8* _tmp6_;
		gint _tmp6__length1;
		gint _tmp7_;
		gint _tmp8_;
#line 332 "../common/key-manager-store.vala"
		_tmp2_ = gdk_drag_context_get_source_window (context);
#line 332 "../common/key-manager-store.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 332 "../common/key-manager-store.vala"
		source_window = _tmp3_;
#line 333 "../common/key-manager-store.vala"
		_tmp4_ = source_window;
#line 333 "../common/key-manager-store.vala"
		_tmp5_ = string_get_data (SEAHORSE_KEY_MANAGER_STORE_XDS_FILENAME, &_tmp5__length1);
#line 333 "../common/key-manager-store.vala"
		_tmp6_ = _tmp5_;
#line 333 "../common/key-manager-store.vala"
		_tmp6__length1 = _tmp5__length1;
#line 333 "../common/key-manager-store.vala"
		_tmp7_ = strlen (SEAHORSE_KEY_MANAGER_STORE_XDS_FILENAME);
#line 333 "../common/key-manager-store.vala"
		_tmp8_ = _tmp7_;
#line 333 "../common/key-manager-store.vala"
		gdk_property_change (_tmp4_, seahorse_key_manager_store_XDS_ATOM, seahorse_key_manager_store_TEXT_ATOM, 8, GDK_PROP_MODE_REPLACE, (const guchar*) _tmp6_, _tmp8_);
#line 331 "../common/key-manager-store.vala"
		_g_object_unref0 (source_window);
#line 1703 "key-manager-store.c"
	}
#line 337 "../common/key-manager-store.vala"
	g_debug ("key-manager-store.vala:337: drag_begin <--");
#line 1707 "key-manager-store.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 350 "../common/key-manager-store.vala"
	return self ? g_error_copy (self) : NULL;
#line 1715 "key-manager-store.c"
}

static gboolean
seahorse_key_manager_store_export_to_text (SeahorseKeyManagerStore* self,
                                           GtkSelectionData* selection_data)
{
	gboolean result = FALSE;
	GList* _tmp0_;
	guint8* output = NULL;
	gint output_length1 = 0;
	gint _output_size_ = 0;
	guint count = 0U;
	GError* _inner_error0_ = NULL;
#line 340 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 340 "../common/key-manager-store.vala"
	g_return_val_if_fail (selection_data != NULL, FALSE);
#line 341 "../common/key-manager-store.vala"
	_tmp0_ = self->priv->drag_objects;
#line 341 "../common/key-manager-store.vala"
	if (_tmp0_ == NULL) {
#line 342 "../common/key-manager-store.vala"
		result = FALSE;
#line 342 "../common/key-manager-store.vala"
		return result;
#line 1741 "key-manager-store.c"
	}
#line 343 "../common/key-manager-store.vala"
	g_debug ("key-manager-store.vala:343: exporting to text");
#line 346 "../common/key-manager-store.vala"
	count = (guint) 0;
#line 1747 "key-manager-store.c"
	{
		guint _tmp1_ = 0U;
		GList* _tmp2_;
		guint8* _tmp3_ = NULL;
		size_t _tmp4_ = 0;
		guint _tmp5_;
#line 348 "../common/key-manager-store.vala"
		_tmp2_ = self->priv->drag_objects;
#line 348 "../common/key-manager-store.vala"
		_tmp5_ = seahorse_exportable_export_to_text_wait (_tmp2_, &_tmp3_, &_tmp4_, &_inner_error0_);
#line 348 "../common/key-manager-store.vala"
		output = (g_free (output), NULL);
#line 348 "../common/key-manager-store.vala"
		output = _tmp3_;
#line 348 "../common/key-manager-store.vala"
		output_length1 = _tmp4_;
#line 348 "../common/key-manager-store.vala"
		_output_size_ = output_length1;
#line 348 "../common/key-manager-store.vala"
		_tmp1_ = _tmp5_;
#line 348 "../common/key-manager-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1770 "key-manager-store.c"
			goto __catch5_g_error;
		}
#line 348 "../common/key-manager-store.vala"
		count = _tmp1_;
#line 1775 "key-manager-store.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 347 "../common/key-manager-store.vala"
		e = _inner_error0_;
#line 347 "../common/key-manager-store.vala"
		_inner_error0_ = NULL;
#line 350 "../common/key-manager-store.vala"
		_tmp6_ = e;
#line 350 "../common/key-manager-store.vala"
		_tmp7_ = _g_error_copy0 (_tmp6_);
#line 350 "../common/key-manager-store.vala"
		_g_error_free0 (self->priv->drag_error);
#line 350 "../common/key-manager-store.vala"
		self->priv->drag_error = _tmp7_;
#line 351 "../common/key-manager-store.vala"
		_tmp8_ = self->priv->drag_error;
#line 351 "../common/key-manager-store.vala"
		_tmp9_ = _tmp8_->message;
#line 351 "../common/key-manager-store.vala"
		g_message ("key-manager-store.vala:351: error occurred on export: %s", _tmp9_);
#line 352 "../common/key-manager-store.vala"
		result = FALSE;
#line 352 "../common/key-manager-store.vala"
		_g_error_free0 (e);
#line 352 "../common/key-manager-store.vala"
		output = (g_free (output), NULL);
#line 352 "../common/key-manager-store.vala"
		return result;
#line 1811 "key-manager-store.c"
	}
	__finally5:
#line 347 "../common/key-manager-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1816 "key-manager-store.c"
		gboolean _tmp10_ = FALSE;
#line 347 "../common/key-manager-store.vala"
		output = (g_free (output), NULL);
#line 347 "../common/key-manager-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 347 "../common/key-manager-store.vala"
		g_clear_error (&_inner_error0_);
#line 347 "../common/key-manager-store.vala"
		return _tmp10_;
#line 1826 "key-manager-store.c"
	}
#line 357 "../common/key-manager-store.vala"
	if (count > ((guint) 0)) {
#line 1830 "key-manager-store.c"
		guint8* _tmp11_;
		gint _tmp11__length1;
		guint8* _tmp12_;
		gint _tmp12__length1;
#line 358 "../common/key-manager-store.vala"
		g_debug ("key-manager-store.vala:358: setting selection text");
#line 359 "../common/key-manager-store.vala"
		_tmp11_ = output;
#line 359 "../common/key-manager-store.vala"
		_tmp11__length1 = output_length1;
#line 359 "../common/key-manager-store.vala"
		_tmp12_ = output;
#line 359 "../common/key-manager-store.vala"
		_tmp12__length1 = output_length1;
#line 359 "../common/key-manager-store.vala"
		gtk_selection_data_set_text (selection_data, (const gchar*) _tmp11_, _tmp12__length1);
#line 360 "../common/key-manager-store.vala"
		result = TRUE;
#line 360 "../common/key-manager-store.vala"
		output = (g_free (output), NULL);
#line 360 "../common/key-manager-store.vala"
		return result;
#line 1853 "key-manager-store.c"
	}
#line 363 "../common/key-manager-store.vala"
	g_message ("key-manager-store.vala:363: no objects exported");
#line 364 "../common/key-manager-store.vala"
	result = FALSE;
#line 364 "../common/key-manager-store.vala"
	output = (g_free (output), NULL);
#line 364 "../common/key-manager-store.vala"
	return result;
#line 1863 "key-manager-store.c"
}

static gboolean
seahorse_key_manager_store_export_to_directory (SeahorseKeyManagerStore* self,
                                                const gchar* directory)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 367 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 367 "../common/key-manager-store.vala"
	g_return_val_if_fail (directory != NULL, FALSE);
#line 368 "../common/key-manager-store.vala"
	g_debug ("key-manager-store.vala:368: exporting to %s", directory);
#line 1878 "key-manager-store.c"
	{
		GList* _tmp0_;
#line 370 "../common/key-manager-store.vala"
		_tmp0_ = self->priv->drag_objects;
#line 370 "../common/key-manager-store.vala"
		seahorse_exportable_export_to_directory_wait (_tmp0_, directory, &_inner_error0_);
#line 370 "../common/key-manager-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1887 "key-manager-store.c"
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		GError* _tmp2_;
#line 369 "../common/key-manager-store.vala"
		e = _inner_error0_;
#line 369 "../common/key-manager-store.vala"
		_inner_error0_ = NULL;
#line 372 "../common/key-manager-store.vala"
		_tmp1_ = e;
#line 372 "../common/key-manager-store.vala"
		_tmp2_ = _g_error_copy0 (_tmp1_);
#line 372 "../common/key-manager-store.vala"
		_g_error_free0 (self->priv->drag_error);
#line 372 "../common/key-manager-store.vala"
		self->priv->drag_error = _tmp2_;
#line 373 "../common/key-manager-store.vala"
		result = FALSE;
#line 373 "../common/key-manager-store.vala"
		_g_error_free0 (e);
#line 373 "../common/key-manager-store.vala"
		return result;
#line 1915 "key-manager-store.c"
	}
	__finally6:
#line 369 "../common/key-manager-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1920 "key-manager-store.c"
		gboolean _tmp3_ = FALSE;
#line 369 "../common/key-manager-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 369 "../common/key-manager-store.vala"
		g_clear_error (&_inner_error0_);
#line 369 "../common/key-manager-store.vala"
		return _tmp3_;
#line 1928 "key-manager-store.c"
	}
#line 375 "../common/key-manager-store.vala"
	result = TRUE;
#line 375 "../common/key-manager-store.vala"
	return result;
#line 1934 "key-manager-store.c"
}

static void
seahorse_key_manager_store_drag_data_get (SeahorseKeyManagerStore* self,
                                          GtkWidget* widget,
                                          GdkDragContext* context,
                                          GtkSelectionData* selection_data,
                                          guint info,
                                          guint time)
{
	GList* _tmp0_;
#line 378 "../common/key-manager-store.vala"
	g_return_if_fail (self != NULL);
#line 378 "../common/key-manager-store.vala"
	g_return_if_fail (widget != NULL);
#line 378 "../common/key-manager-store.vala"
	g_return_if_fail (context != NULL);
#line 378 "../common/key-manager-store.vala"
	g_return_if_fail (selection_data != NULL);
#line 380 "../common/key-manager-store.vala"
	_tmp0_ = self->priv->drag_objects;
#line 380 "../common/key-manager-store.vala"
	if (_tmp0_ == NULL) {
#line 381 "../common/key-manager-store.vala"
		return;
#line 1960 "key-manager-store.c"
	}
#line 383 "../common/key-manager-store.vala"
	g_debug ("key-manager-store.vala:383: drag_data_get %u -.", info);
#line 386 "../common/key-manager-store.vala"
	if (info == ((guint) SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT)) {
#line 387 "../common/key-manager-store.vala"
		g_debug ("key-manager-store.vala:387: returning object text");
#line 388 "../common/key-manager-store.vala"
		seahorse_key_manager_store_export_to_text (self, selection_data);
#line 1970 "key-manager-store.c"
	} else {
#line 391 "../common/key-manager-store.vala"
		if (info == ((guint) SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS)) {
#line 393 "../common/key-manager-store.vala"
			if (seahorse_key_manager_store_xds_is_dnd_valid_context (self, context)) {
#line 1976 "key-manager-store.c"
				gchar* destination = NULL;
				gchar* _tmp1_;
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				gchar* _tmp4_;
				guint8* _tmp5_;
				gint _tmp5__length1;
				guint8* _tmp6_;
				gint _tmp6__length1;
#line 394 "../common/key-manager-store.vala"
				_tmp1_ = seahorse_key_manager_store_xds_get_atom_value (self, context);
#line 394 "../common/key-manager-store.vala"
				destination = _tmp1_;
#line 395 "../common/key-manager-store.vala"
				_tmp2_ = destination;
#line 395 "../common/key-manager-store.vala"
				if (_tmp2_ == NULL) {
#line 396 "../common/key-manager-store.vala"
					_g_free0 (destination);
#line 396 "../common/key-manager-store.vala"
					return;
#line 1998 "key-manager-store.c"
				}
#line 397 "../common/key-manager-store.vala"
				_tmp3_ = destination;
#line 397 "../common/key-manager-store.vala"
				_tmp4_ = g_path_get_dirname (_tmp3_);
#line 397 "../common/key-manager-store.vala"
				_g_free0 (self->priv->drag_destination);
#line 397 "../common/key-manager-store.vala"
				self->priv->drag_destination = _tmp4_;
#line 399 "../common/key-manager-store.vala"
				_tmp5_ = string_get_data ("S", &_tmp5__length1);
#line 399 "../common/key-manager-store.vala"
				_tmp6_ = _tmp5_;
#line 399 "../common/key-manager-store.vala"
				_tmp6__length1 = _tmp5__length1;
#line 399 "../common/key-manager-store.vala"
				gtk_selection_data_set (selection_data, gtk_selection_data_get_target (selection_data), 8, _tmp6_, (gint) _tmp6__length1);
#line 393 "../common/key-manager-store.vala"
				_g_free0 (destination);
#line 2018 "key-manager-store.c"
			}
		} else {
#line 404 "../common/key-manager-store.vala"
			g_debug ("key-manager-store.vala:404: Unrecognized format: %u", info);
#line 2023 "key-manager-store.c"
		}
	}
#line 407 "../common/key-manager-store.vala"
	g_debug ("key-manager-store.vala:407: drag_data_get <--");
#line 2028 "key-manager-store.c"
}

static void
seahorse_key_manager_store_drag_end (SeahorseKeyManagerStore* self,
                                     GtkWidget* widget,
                                     GdkDragContext* context)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GError* _tmp4_;
#line 410 "../common/key-manager-store.vala"
	g_return_if_fail (self != NULL);
#line 411 "../common/key-manager-store.vala"
	g_debug ("key-manager-store.vala:411: drag_end -.");
#line 413 "../common/key-manager-store.vala"
	_tmp1_ = self->priv->drag_destination;
#line 413 "../common/key-manager-store.vala"
	if (_tmp1_ != NULL) {
#line 2047 "key-manager-store.c"
		GError* _tmp2_;
#line 413 "../common/key-manager-store.vala"
		_tmp2_ = self->priv->drag_error;
#line 413 "../common/key-manager-store.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 2053 "key-manager-store.c"
	} else {
#line 413 "../common/key-manager-store.vala"
		_tmp0_ = FALSE;
#line 2057 "key-manager-store.c"
	}
#line 413 "../common/key-manager-store.vala"
	if (_tmp0_) {
#line 2061 "key-manager-store.c"
		const gchar* _tmp3_;
#line 414 "../common/key-manager-store.vala"
		_tmp3_ = self->priv->drag_destination;
#line 414 "../common/key-manager-store.vala"
		seahorse_key_manager_store_export_to_directory (self, _tmp3_);
#line 2067 "key-manager-store.c"
	}
#line 416 "../common/key-manager-store.vala"
	_tmp4_ = self->priv->drag_error;
#line 416 "../common/key-manager-store.vala"
	if (_tmp4_ != NULL) {
#line 2073 "key-manager-store.c"
		GError* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 417 "../common/key-manager-store.vala"
		_tmp5_ = self->priv->drag_error;
#line 417 "../common/key-manager-store.vala"
		g_dbus_error_strip_remote_error (_tmp5_);
#line 418 "../common/key-manager-store.vala"
		_tmp6_ = self->priv->drag_error;
#line 418 "../common/key-manager-store.vala"
		_tmp7_ = _tmp6_->message;
#line 418 "../common/key-manager-store.vala"
		seahorse_util_show_error (widget, _ ("Couldn’t export keys"), _tmp7_);
#line 2087 "key-manager-store.c"
	}
#line 421 "../common/key-manager-store.vala"
	_g_error_free0 (self->priv->drag_error);
#line 421 "../common/key-manager-store.vala"
	self->priv->drag_error = NULL;
#line 422 "../common/key-manager-store.vala"
	(self->priv->drag_objects == NULL) ? NULL : (self->priv->drag_objects = (_g_list_free__g_object_unref0_ (self->priv->drag_objects), NULL));
#line 422 "../common/key-manager-store.vala"
	self->priv->drag_objects = NULL;
#line 423 "../common/key-manager-store.vala"
	_g_free0 (self->priv->drag_destination);
#line 423 "../common/key-manager-store.vala"
	self->priv->drag_destination = NULL;
#line 425 "../common/key-manager-store.vala"
	g_debug ("key-manager-store.vala:425: drag_end <--");
#line 2103 "key-manager-store.c"
}

static GtkTreeIter*
_gtk_tree_iter_dup (GtkTreeIter* self)
{
	GtkTreeIter* dup;
#line 430 "../common/key-manager-store.vala"
	dup = g_new0 (GtkTreeIter, 1);
#line 430 "../common/key-manager-store.vala"
	memcpy (dup, self, sizeof (GtkTreeIter));
#line 430 "../common/key-manager-store.vala"
	return dup;
#line 2116 "key-manager-store.c"
}

static gpointer
__gtk_tree_iter_dup0 (gpointer self)
{
#line 430 "../common/key-manager-store.vala"
	return self ? _gtk_tree_iter_dup (self) : NULL;
#line 2124 "key-manager-store.c"
}

GObject*
seahorse_key_manager_store_get_object_from_path (GtkTreeView* view,
                                                 GtkTreePath* path)
{
	GObject* result = NULL;
	GtkTreeIter* iter = NULL;
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	GtkTreeIter _tmp4_;
	GtkTreeIter* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeIter* _tmp8_;
	GtkTreeIter _tmp9_;
	GObject* _tmp10_;
	GObject* _tmp11_;
#line 428 "../common/key-manager-store.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 430 "../common/key-manager-store.vala"
	_tmp0_ = gtk_tree_view_get_model (view);
#line 430 "../common/key-manager-store.vala"
	_tmp1_ = _tmp0_;
#line 430 "../common/key-manager-store.vala"
	_tmp3_ = gtk_tree_model_get_iter (_tmp1_, &_tmp2_, path);
#line 430 "../common/key-manager-store.vala"
	_g_free0 (iter);
#line 430 "../common/key-manager-store.vala"
	_tmp4_ = _tmp2_;
#line 430 "../common/key-manager-store.vala"
	_tmp5_ = __gtk_tree_iter_dup0 (&_tmp4_);
#line 430 "../common/key-manager-store.vala"
	iter = _tmp5_;
#line 430 "../common/key-manager-store.vala"
	if (!_tmp3_) {
#line 431 "../common/key-manager-store.vala"
		result = NULL;
#line 431 "../common/key-manager-store.vala"
		_g_free0 (iter);
#line 431 "../common/key-manager-store.vala"
		return result;
#line 2169 "key-manager-store.c"
	}
#line 432 "../common/key-manager-store.vala"
	_tmp6_ = gtk_tree_view_get_model (view);
#line 432 "../common/key-manager-store.vala"
	_tmp7_ = _tmp6_;
#line 432 "../common/key-manager-store.vala"
	_tmp8_ = iter;
#line 432 "../common/key-manager-store.vala"
	_tmp9_ = *_tmp8_;
#line 432 "../common/key-manager-store.vala"
	_tmp10_ = gcr_collection_model_object_for_iter (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gcr_collection_model_get_type (), GcrCollectionModel), &_tmp9_);
#line 432 "../common/key-manager-store.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 432 "../common/key-manager-store.vala"
	result = _tmp11_;
#line 432 "../common/key-manager-store.vala"
	_g_free0 (iter);
#line 432 "../common/key-manager-store.vala"
	return result;
#line 2189 "key-manager-store.c"
}

GList*
seahorse_key_manager_store_get_all_objects (SeahorseKeyManagerStore* self)
{
	GList* result = NULL;
	GcrCollection* _tmp0_;
	GList* _tmp1_;
#line 435 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 436 "../common/key-manager-store.vala"
	_tmp0_ = gcr_collection_model_get_collection ((GcrCollectionModel*) self);
#line 436 "../common/key-manager-store.vala"
	_tmp1_ = gcr_collection_get_objects (_tmp0_);
#line 436 "../common/key-manager-store.vala"
	result = _tmp1_;
#line 436 "../common/key-manager-store.vala"
	return result;
#line 2208 "key-manager-store.c"
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 444 "../common/key-manager-store.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 2216 "key-manager-store.c"
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 444 "../common/key-manager-store.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 2224 "key-manager-store.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 444 "../common/key-manager-store.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 2232 "key-manager-store.c"
}

static gint
__lambda15_ (GObject* a,
             GObject* b)
{
	gint result = 0;
	gint _tmp0_ = 0;
#line 451 "../common/key-manager-store.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 451 "../common/key-manager-store.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 452 "../common/key-manager-store.vala"
	if (a == b) {
#line 453 "../common/key-manager-store.vala"
		result = 0;
#line 453 "../common/key-manager-store.vala"
		return result;
#line 2251 "key-manager-store.c"
	}
#line 454 "../common/key-manager-store.vala"
	if (((void*) a) > ((void*) b)) {
#line 454 "../common/key-manager-store.vala"
		_tmp0_ = 1;
#line 2257 "key-manager-store.c"
	} else {
#line 454 "../common/key-manager-store.vala"
		_tmp0_ = -1;
#line 2261 "key-manager-store.c"
	}
#line 454 "../common/key-manager-store.vala"
	result = _tmp0_;
#line 454 "../common/key-manager-store.vala"
	return result;
#line 2267 "key-manager-store.c"
}

static gint
___lambda15__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda15_ ((GObject*) a, (GObject*) b);
#line 451 "../common/key-manager-store.vala"
	return result;
#line 2278 "key-manager-store.c"
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 463 "../common/key-manager-store.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 2286 "key-manager-store.c"
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 463 "../common/key-manager-store.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 2294 "key-manager-store.c"
}

GList*
seahorse_key_manager_store_get_selected_objects (GtkTreeView* view)
{
	GList* result = NULL;
	GList* paths = NULL;
	GtkTreeSelection* _tmp0_;
	GList* _tmp1_;
	GList* objects = NULL;
	GList* _tmp2_;
	GList* l = NULL;
#line 439 "../common/key-manager-store.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 440 "../common/key-manager-store.vala"
	_tmp0_ = gtk_tree_view_get_selection (view);
#line 440 "../common/key-manager-store.vala"
	_tmp1_ = gtk_tree_selection_get_selected_rows (_tmp0_, NULL);
#line 440 "../common/key-manager-store.vala"
	paths = _tmp1_;
#line 443 "../common/key-manager-store.vala"
	objects = NULL;
#line 444 "../common/key-manager-store.vala"
	_tmp2_ = paths;
#line 2319 "key-manager-store.c"
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
#line 444 "../common/key-manager-store.vala"
		path_collection = _tmp2_;
#line 444 "../common/key-manager-store.vala"
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
#line 2327 "key-manager-store.c"
			GtkTreePath* _tmp3_;
			GtkTreePath* path = NULL;
#line 444 "../common/key-manager-store.vala"
			_tmp3_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) path_it->data);
#line 444 "../common/key-manager-store.vala"
			path = _tmp3_;
#line 2334 "key-manager-store.c"
			{
				GObject* obj = NULL;
				GtkTreePath* _tmp4_;
				GObject* _tmp5_;
				GObject* _tmp6_;
#line 445 "../common/key-manager-store.vala"
				_tmp4_ = path;
#line 445 "../common/key-manager-store.vala"
				_tmp5_ = seahorse_key_manager_store_get_object_from_path (view, _tmp4_);
#line 445 "../common/key-manager-store.vala"
				obj = _tmp5_;
#line 446 "../common/key-manager-store.vala"
				_tmp6_ = obj;
#line 446 "../common/key-manager-store.vala"
				if (_tmp6_ != NULL) {
#line 2350 "key-manager-store.c"
					GObject* _tmp7_;
					GObject* _tmp8_;
#line 447 "../common/key-manager-store.vala"
					_tmp7_ = obj;
#line 447 "../common/key-manager-store.vala"
					_tmp8_ = _g_object_ref0 (_tmp7_);
#line 447 "../common/key-manager-store.vala"
					objects = g_list_append (objects, _tmp8_);
#line 2359 "key-manager-store.c"
				}
#line 444 "../common/key-manager-store.vala"
				_g_object_unref0 (obj);
#line 444 "../common/key-manager-store.vala"
				__vala_GtkTreePath_free0 (path);
#line 2365 "key-manager-store.c"
			}
		}
	}
#line 451 "../common/key-manager-store.vala"
	objects = g_list_sort (objects, ___lambda15__gcompare_func);
#line 457 "../common/key-manager-store.vala"
	l = NULL;
#line 2373 "key-manager-store.c"
	{
		GList* _tmp9_;
		gboolean _tmp10_ = FALSE;
#line 458 "../common/key-manager-store.vala"
		_tmp9_ = objects;
#line 458 "../common/key-manager-store.vala"
		l = _tmp9_;
#line 458 "../common/key-manager-store.vala"
		_tmp10_ = TRUE;
#line 458 "../common/key-manager-store.vala"
		while (TRUE) {
#line 2385 "key-manager-store.c"
			GList* _tmp13_;
#line 458 "../common/key-manager-store.vala"
			if (!_tmp10_) {
#line 2389 "key-manager-store.c"
				GList* _tmp11_;
				GList* _tmp12_;
#line 458 "../common/key-manager-store.vala"
				_tmp11_ = l;
#line 458 "../common/key-manager-store.vala"
				_tmp12_ = _tmp11_->next;
#line 458 "../common/key-manager-store.vala"
				l = _tmp12_;
#line 2398 "key-manager-store.c"
			}
#line 458 "../common/key-manager-store.vala"
			_tmp10_ = FALSE;
#line 458 "../common/key-manager-store.vala"
			_tmp13_ = l;
#line 458 "../common/key-manager-store.vala"
			if (!(_tmp13_ != NULL)) {
#line 458 "../common/key-manager-store.vala"
				break;
#line 2408 "key-manager-store.c"
			}
#line 459 "../common/key-manager-store.vala"
			while (TRUE) {
#line 2412 "key-manager-store.c"
				gboolean _tmp14_ = FALSE;
				GList* _tmp15_;
				GList* _tmp16_;
				GList* _tmp22_;
				GList* _tmp23_;
#line 459 "../common/key-manager-store.vala"
				_tmp15_ = l;
#line 459 "../common/key-manager-store.vala"
				_tmp16_ = _tmp15_->next;
#line 459 "../common/key-manager-store.vala"
				if (_tmp16_ != NULL) {
#line 2424 "key-manager-store.c"
					GList* _tmp17_;
					gconstpointer _tmp18_;
					GList* _tmp19_;
					GList* _tmp20_;
					gconstpointer _tmp21_;
#line 459 "../common/key-manager-store.vala"
					_tmp17_ = l;
#line 459 "../common/key-manager-store.vala"
					_tmp18_ = _tmp17_->data;
#line 459 "../common/key-manager-store.vala"
					_tmp19_ = l;
#line 459 "../common/key-manager-store.vala"
					_tmp20_ = _tmp19_->next;
#line 459 "../common/key-manager-store.vala"
					_tmp21_ = _tmp20_->data;
#line 459 "../common/key-manager-store.vala"
					_tmp14_ = ((GObject*) _tmp18_) == ((GObject*) _tmp21_);
#line 2442 "key-manager-store.c"
				} else {
#line 459 "../common/key-manager-store.vala"
					_tmp14_ = FALSE;
#line 2446 "key-manager-store.c"
				}
#line 459 "../common/key-manager-store.vala"
				if (!_tmp14_) {
#line 459 "../common/key-manager-store.vala"
					break;
#line 2452 "key-manager-store.c"
				}
#line 460 "../common/key-manager-store.vala"
				_tmp22_ = l;
#line 460 "../common/key-manager-store.vala"
				_tmp23_ = _tmp22_->next;
#line 460 "../common/key-manager-store.vala"
				objects = g_list_delete_link (objects, _tmp23_);
#line 2460 "key-manager-store.c"
			}
		}
	}
#line 463 "../common/key-manager-store.vala"
	result = objects;
#line 463 "../common/key-manager-store.vala"
	(paths == NULL) ? NULL : (paths = (_g_list_free___vala_GtkTreePath_free0_ (paths), NULL));
#line 463 "../common/key-manager-store.vala"
	return result;
#line 2470 "key-manager-store.c"
}

void
seahorse_key_manager_store_set_selected_objects (GtkTreeView* view,
                                                 GList* objects)
{
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp2_;
	gboolean first = FALSE;
#line 466 "../common/key-manager-store.vala"
	g_return_if_fail (view != NULL);
#line 467 "../common/key-manager-store.vala"
	_tmp0_ = gtk_tree_view_get_selection (view);
#line 467 "../common/key-manager-store.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 467 "../common/key-manager-store.vala"
	selection = _tmp1_;
#line 468 "../common/key-manager-store.vala"
	_tmp2_ = selection;
#line 468 "../common/key-manager-store.vala"
	gtk_tree_selection_unselect_all (_tmp2_);
#line 470 "../common/key-manager-store.vala"
	first = TRUE;
#line 2496 "key-manager-store.c"
	{
		GList* obj_collection = NULL;
		GList* obj_it = NULL;
#line 471 "../common/key-manager-store.vala"
		obj_collection = objects;
#line 471 "../common/key-manager-store.vala"
		for (obj_it = obj_collection; obj_it != NULL; obj_it = obj_it->next) {
#line 2504 "key-manager-store.c"
			GObject* _tmp3_;
			GObject* obj = NULL;
#line 471 "../common/key-manager-store.vala"
			_tmp3_ = _g_object_ref0 ((GObject*) obj_it->data);
#line 471 "../common/key-manager-store.vala"
			obj = _tmp3_;
#line 2511 "key-manager-store.c"
			{
				GtkTreeIter iter = {0};
				GtkTreeModel* _tmp4_;
				GtkTreeModel* _tmp5_;
				GObject* _tmp6_;
				GtkTreeIter _tmp7_;
#line 472 "../common/key-manager-store.vala"
				memset (&iter, 0, sizeof (GtkTreeIter));
#line 473 "../common/key-manager-store.vala"
				_tmp4_ = gtk_tree_view_get_model (view);
#line 473 "../common/key-manager-store.vala"
				_tmp5_ = _tmp4_;
#line 473 "../common/key-manager-store.vala"
				_tmp6_ = obj;
#line 473 "../common/key-manager-store.vala"
				_tmp7_ = iter;
#line 473 "../common/key-manager-store.vala"
				if (gcr_collection_model_iter_for_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gcr_collection_model_get_type (), GcrCollectionModel), _tmp6_, &_tmp7_)) {
#line 2530 "key-manager-store.c"
					GtkTreeSelection* _tmp8_;
					GtkTreeIter _tmp9_;
#line 474 "../common/key-manager-store.vala"
					_tmp8_ = selection;
#line 474 "../common/key-manager-store.vala"
					_tmp9_ = iter;
#line 474 "../common/key-manager-store.vala"
					gtk_tree_selection_select_iter (_tmp8_, &_tmp9_);
#line 477 "../common/key-manager-store.vala"
					if (first) {
#line 2541 "key-manager-store.c"
						GtkTreePath* path = NULL;
						GtkTreeModel* _tmp10_;
						GtkTreeModel* _tmp11_;
						GtkTreeIter _tmp12_;
						GtkTreePath* _tmp13_;
						GtkTreePath* _tmp14_;
#line 478 "../common/key-manager-store.vala"
						_tmp10_ = gtk_tree_view_get_model (view);
#line 478 "../common/key-manager-store.vala"
						_tmp11_ = _tmp10_;
#line 478 "../common/key-manager-store.vala"
						_tmp12_ = iter;
#line 478 "../common/key-manager-store.vala"
						_tmp13_ = gtk_tree_model_get_path (_tmp11_, &_tmp12_);
#line 478 "../common/key-manager-store.vala"
						path = _tmp13_;
#line 479 "../common/key-manager-store.vala"
						_tmp14_ = path;
#line 479 "../common/key-manager-store.vala"
						gtk_tree_view_scroll_to_cell (view, _tmp14_, NULL, FALSE, 0.0f, 0.0f);
#line 480 "../common/key-manager-store.vala"
						first = FALSE;
#line 477 "../common/key-manager-store.vala"
						__vala_GtkTreePath_free0 (path);
#line 2566 "key-manager-store.c"
					}
				}
#line 471 "../common/key-manager-store.vala"
				_g_object_unref0 (obj);
#line 2571 "key-manager-store.c"
			}
		}
	}
#line 466 "../common/key-manager-store.vala"
	_g_object_unref0 (selection);
#line 2577 "key-manager-store.c"
}

GObject*
seahorse_key_manager_store_get_selected_object (SeahorseKeyManagerStore* self,
                                                GtkTreeView* view)
{
	GObject* result = NULL;
	GList* paths = NULL;
	GtkTreeSelection* _tmp0_;
	GList* _tmp1_;
	GObject* obj = NULL;
	GList* _tmp2_;
#line 486 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 487 "../common/key-manager-store.vala"
	_tmp0_ = gtk_tree_view_get_selection (view);
#line 487 "../common/key-manager-store.vala"
	_tmp1_ = gtk_tree_selection_get_selected_rows (_tmp0_, NULL);
#line 487 "../common/key-manager-store.vala"
	paths = _tmp1_;
#line 490 "../common/key-manager-store.vala"
	obj = NULL;
#line 491 "../common/key-manager-store.vala"
	_tmp2_ = paths;
#line 491 "../common/key-manager-store.vala"
	if (_tmp2_ != NULL) {
#line 2604 "key-manager-store.c"
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GObject* _tmp5_;
#line 492 "../common/key-manager-store.vala"
		_tmp3_ = paths;
#line 492 "../common/key-manager-store.vala"
		_tmp4_ = _tmp3_->data;
#line 492 "../common/key-manager-store.vala"
		_tmp5_ = seahorse_key_manager_store_get_object_from_path (view, (GtkTreePath*) _tmp4_);
#line 492 "../common/key-manager-store.vala"
		_g_object_unref0 (obj);
#line 492 "../common/key-manager-store.vala"
		obj = _tmp5_;
#line 2618 "key-manager-store.c"
	}
#line 494 "../common/key-manager-store.vala"
	result = obj;
#line 494 "../common/key-manager-store.vala"
	(paths == NULL) ? NULL : (paths = (_g_list_free___vala_GtkTreePath_free0_ (paths), NULL));
#line 494 "../common/key-manager-store.vala"
	return result;
#line 2626 "key-manager-store.c"
}

GSettings*
seahorse_key_manager_store_get_settings (SeahorseKeyManagerStore* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 82 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "../common/key-manager-store.vala"
	_tmp0_ = self->priv->_settings;
#line 82 "../common/key-manager-store.vala"
	result = _tmp0_;
#line 82 "../common/key-manager-store.vala"
	return result;
#line 2642 "key-manager-store.c"
}

void
seahorse_key_manager_store_set_settings (SeahorseKeyManagerStore* self,
                                         GSettings* value)
{
#line 82 "../common/key-manager-store.vala"
	g_return_if_fail (self != NULL);
#line 82 "../common/key-manager-store.vala"
	if (seahorse_key_manager_store_get_settings (self) != value) {
#line 2653 "key-manager-store.c"
		GSettings* _tmp0_;
#line 82 "../common/key-manager-store.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 82 "../common/key-manager-store.vala"
		_g_object_unref0 (self->priv->_settings);
#line 82 "../common/key-manager-store.vala"
		self->priv->_settings = _tmp0_;
#line 82 "../common/key-manager-store.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY]);
#line 2663 "key-manager-store.c"
	}
}

const gchar*
seahorse_key_manager_store_get_filter (SeahorseKeyManagerStore* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 88 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 88 "../common/key-manager-store.vala"
	_tmp0_ = self->priv->_filter;
#line 88 "../common/key-manager-store.vala"
	result = _tmp0_;
#line 88 "../common/key-manager-store.vala"
	return result;
#line 2680 "key-manager-store.c"
}

void
seahorse_key_manager_store_set_filter (SeahorseKeyManagerStore* self,
                                       const gchar* value)
{
	const gchar* _tmp0_;
#line 89 "../common/key-manager-store.vala"
	g_return_if_fail (self != NULL);
#line 90 "../common/key-manager-store.vala"
	_tmp0_ = self->priv->_filter;
#line 90 "../common/key-manager-store.vala"
	if (g_strcmp0 (_tmp0_, value) != 0) {
#line 2694 "key-manager-store.c"
		gchar* _tmp1_;
#line 91 "../common/key-manager-store.vala"
		_tmp1_ = g_strdup (value);
#line 91 "../common/key-manager-store.vala"
		_g_free0 (self->priv->_filter);
#line 91 "../common/key-manager-store.vala"
		self->priv->_filter = _tmp1_;
#line 92 "../common/key-manager-store.vala"
		seahorse_key_manager_store_refilter (self);
#line 2704 "key-manager-store.c"
	}
#line 89 "../common/key-manager-store.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY]);
#line 2708 "key-manager-store.c"
}

SeahorseKeyManagerStoreShowFilter
seahorse_key_manager_store_get_showfilter (SeahorseKeyManagerStore* self)
{
	SeahorseKeyManagerStoreShowFilter result;
	SeahorseKeyManagerStoreShowFilter _tmp0_;
#line 98 "../common/key-manager-store.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 98 "../common/key-manager-store.vala"
	_tmp0_ = self->priv->_showfilter;
#line 98 "../common/key-manager-store.vala"
	result = _tmp0_;
#line 98 "../common/key-manager-store.vala"
	return result;
#line 2724 "key-manager-store.c"
}

void
seahorse_key_manager_store_set_showfilter (SeahorseKeyManagerStore* self,
                                           SeahorseKeyManagerStoreShowFilter value)
{
#line 98 "../common/key-manager-store.vala"
	g_return_if_fail (self != NULL);
#line 98 "../common/key-manager-store.vala"
	if (seahorse_key_manager_store_get_showfilter (self) != value) {
#line 98 "../common/key-manager-store.vala"
		self->priv->_showfilter = value;
#line 98 "../common/key-manager-store.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY]);
#line 2739 "key-manager-store.c"
	}
}

static GObject *
seahorse_key_manager_store_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseKeyManagerStore * self;
	GcrColumn* _tmp0_;
	gint _tmp0__length1;
#line 118 "../common/key-manager-store.vala"
	parent_class = G_OBJECT_CLASS (seahorse_key_manager_store_parent_class);
#line 118 "../common/key-manager-store.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 118 "../common/key-manager-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore);
#line 120 "../common/key-manager-store.vala"
	_tmp0_ = seahorse_key_manager_store__columns;
#line 120 "../common/key-manager-store.vala"
	_tmp0__length1 = seahorse_key_manager_store__columns_length1;
#line 120 "../common/key-manager-store.vala"
	g_object_set ((GObject*) self, "columns", _tmp0_, "mode", GCR_COLLECTION_MODEL_LIST, NULL, NULL);
#line 118 "../common/key-manager-store.vala"
	return obj;
#line 2767 "key-manager-store.c"
}

static void
seahorse_key_manager_store_class_init (SeahorseKeyManagerStoreClass * klass,
                                       gpointer klass_data)
{
	GcrColumn _tmp0_ = {0};
	GcrColumn _tmp1_ = {0};
	GcrColumn _tmp2_ = {0};
	GcrColumn _tmp3_ = {0};
	GcrColumn _tmp4_ = {0};
	GcrColumn* _tmp5_;
#line 23 "../common/key-manager-store.vala"
	seahorse_key_manager_store_parent_class = g_type_class_peek_parent (klass);
#line 23 "../common/key-manager-store.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseKeyManagerStore_private_offset);
#line 23 "../common/key-manager-store.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_key_manager_store_get_property;
#line 23 "../common/key-manager-store.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_key_manager_store_set_property;
#line 23 "../common/key-manager-store.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_key_manager_store_constructor;
#line 23 "../common/key-manager-store.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_key_manager_store_finalize;
#line 2792 "key-manager-store.c"
	/**
	     * Manager Settings
	     */
#line 23 "../common/key-manager-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 2798 "key-manager-store.c"
	/**
	     * Key store filter
	     */
#line 23 "../common/key-manager-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY] = g_param_spec_string ("filter", "filter", "filter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../common/key-manager-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY] = g_param_spec_enum ("showfilter", "showfilter", "showfilter", SEAHORSE_KEY_MANAGER_STORE_TYPE_SHOW_FILTER, SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../common/key-manager-store.vala"
	seahorse_key_manager_store_XDS_ATOM = gdk_atom_intern ("XdndDirectSave0", FALSE);
#line 28 "../common/key-manager-store.vala"
	seahorse_key_manager_store_TEXT_ATOM = gdk_atom_intern ("text/plain", FALSE);
#line 109 "../common/key-manager-store.vala"
	memset (&_tmp0_, 0, sizeof (GcrColumn));
#line 109 "../common/key-manager-store.vala"
	_tmp0_.property_name = "icon";
#line 109 "../common/key-manager-store.vala"
	_tmp0_.property_type = g_icon_get_type ();
#line 109 "../common/key-manager-store.vala"
	_tmp0_.column_type = g_icon_get_type ();
#line 109 "../common/key-manager-store.vala"
	memset (&_tmp1_, 0, sizeof (GcrColumn));
#line 109 "../common/key-manager-store.vala"
	_tmp1_.property_name = "markup";
#line 109 "../common/key-manager-store.vala"
	_tmp1_.property_type = G_TYPE_STRING;
#line 109 "../common/key-manager-store.vala"
	_tmp1_.column_type = G_TYPE_STRING;
#line 109 "../common/key-manager-store.vala"
	memset (&_tmp2_, 0, sizeof (GcrColumn));
#line 109 "../common/key-manager-store.vala"
	_tmp2_.property_name = "label";
#line 109 "../common/key-manager-store.vala"
	_tmp2_.property_type = G_TYPE_STRING;
#line 109 "../common/key-manager-store.vala"
	_tmp2_.column_type = G_TYPE_STRING;
#line 109 "../common/key-manager-store.vala"
	_tmp2_.flags = GCR_COLUMN_SORTABLE;
#line 109 "../common/key-manager-store.vala"
	memset (&_tmp3_, 0, sizeof (GcrColumn));
#line 109 "../common/key-manager-store.vala"
	_tmp3_.property_name = "description";
#line 109 "../common/key-manager-store.vala"
	_tmp3_.property_type = G_TYPE_STRING;
#line 109 "../common/key-manager-store.vala"
	_tmp3_.column_type = G_TYPE_STRING;
#line 109 "../common/key-manager-store.vala"
	memset (&_tmp4_, 0, sizeof (GcrColumn));
#line 109 "../common/key-manager-store.vala"
	_tmp5_ = g_new0 (GcrColumn, 5);
#line 109 "../common/key-manager-store.vala"
	_tmp5_[0] = _tmp0_;
#line 109 "../common/key-manager-store.vala"
	_tmp5_[1] = _tmp1_;
#line 109 "../common/key-manager-store.vala"
	_tmp5_[2] = _tmp2_;
#line 109 "../common/key-manager-store.vala"
	_tmp5_[3] = _tmp3_;
#line 109 "../common/key-manager-store.vala"
	_tmp5_[4] = _tmp4_;
#line 109 "../common/key-manager-store.vala"
	seahorse_key_manager_store__columns = _tmp5_;
#line 109 "../common/key-manager-store.vala"
	seahorse_key_manager_store__columns_length1 = 5;
#line 2862 "key-manager-store.c"
}

static void
seahorse_key_manager_store_instance_init (SeahorseKeyManagerStore * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
#line 23 "../common/key-manager-store.vala"
	self->priv = seahorse_key_manager_store_get_instance_private (self);
#line 96 "../common/key-manager-store.vala"
	_tmp0_ = g_strdup ("");
#line 96 "../common/key-manager-store.vala"
	self->priv->_filter = _tmp0_;
#line 98 "../common/key-manager-store.vala"
	self->priv->_showfilter = SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY;
#line 2878 "key-manager-store.c"
}

static void
seahorse_key_manager_store_finalize (GObject * obj)
{
	SeahorseKeyManagerStore * self;
#line 23 "../common/key-manager-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore);
#line 187 "../common/key-manager-store.vala"
	g_signal_handlers_disconnect_by_func ((void*) self, (void*) seahorse_key_manager_store_on_sort_column_changed, (void*) self);
#line 75 "../common/key-manager-store.vala"
	_g_free0 (self->priv->drag_destination);
#line 76 "../common/key-manager-store.vala"
	_g_error_free0 (self->priv->drag_error);
#line 77 "../common/key-manager-store.vala"
	(self->priv->drag_objects == NULL) ? NULL : (self->priv->drag_objects = (_g_list_free__g_object_unref0_ (self->priv->drag_objects), NULL));
#line 82 "../common/key-manager-store.vala"
	_g_object_unref0 (self->priv->_settings);
#line 96 "../common/key-manager-store.vala"
	_g_free0 (self->priv->_filter);
#line 23 "../common/key-manager-store.vala"
	G_OBJECT_CLASS (seahorse_key_manager_store_parent_class)->finalize (obj);
#line 2901 "key-manager-store.c"
}

GType
seahorse_key_manager_store_get_type (void)
{
	static volatile gsize seahorse_key_manager_store_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_key_manager_store_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseKeyManagerStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_key_manager_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseKeyManagerStore), 0, (GInstanceInitFunc) seahorse_key_manager_store_instance_init, NULL };
		GType seahorse_key_manager_store_type_id;
		seahorse_key_manager_store_type_id = g_type_register_static (gcr_collection_model_get_type (), "SeahorseKeyManagerStore", &g_define_type_info, 0);
		SeahorseKeyManagerStore_private_offset = g_type_add_instance_private (seahorse_key_manager_store_type_id, sizeof (SeahorseKeyManagerStorePrivate));
		g_once_init_leave (&seahorse_key_manager_store_type_id__volatile, seahorse_key_manager_store_type_id);
	}
	return seahorse_key_manager_store_type_id__volatile;
}

static void
_vala_seahorse_key_manager_store_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	SeahorseKeyManagerStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore);
#line 23 "../common/key-manager-store.vala"
	switch (property_id) {
#line 23 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY:
#line 23 "../common/key-manager-store.vala"
		g_value_set_object (value, seahorse_key_manager_store_get_settings (self));
#line 23 "../common/key-manager-store.vala"
		break;
#line 23 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY:
#line 23 "../common/key-manager-store.vala"
		g_value_set_string (value, seahorse_key_manager_store_get_filter (self));
#line 23 "../common/key-manager-store.vala"
		break;
#line 23 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY:
#line 23 "../common/key-manager-store.vala"
		g_value_set_enum (value, seahorse_key_manager_store_get_showfilter (self));
#line 23 "../common/key-manager-store.vala"
		break;
#line 2946 "key-manager-store.c"
		default:
#line 23 "../common/key-manager-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../common/key-manager-store.vala"
		break;
#line 2952 "key-manager-store.c"
	}
}

static void
_vala_seahorse_key_manager_store_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	SeahorseKeyManagerStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore);
#line 23 "../common/key-manager-store.vala"
	switch (property_id) {
#line 23 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY:
#line 23 "../common/key-manager-store.vala"
		seahorse_key_manager_store_set_settings (self, g_value_get_object (value));
#line 23 "../common/key-manager-store.vala"
		break;
#line 23 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY:
#line 23 "../common/key-manager-store.vala"
		seahorse_key_manager_store_set_filter (self, g_value_get_string (value));
#line 23 "../common/key-manager-store.vala"
		break;
#line 23 "../common/key-manager-store.vala"
		case SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY:
#line 23 "../common/key-manager-store.vala"
		seahorse_key_manager_store_set_showfilter (self, g_value_get_enum (value));
#line 23 "../common/key-manager-store.vala"
		break;
#line 2984 "key-manager-store.c"
		default:
#line 23 "../common/key-manager-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../common/key-manager-store.vala"
		break;
#line 2990 "key-manager-store.c"
	}
}

