/* predicate.c generated by valac 0.44.0, the Vala compiler
 * generated from predicate.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>

typedef gboolean (*SeahorsePredicateFunc) (GObject* obj, void* custom_target);

#define SEAHORSE_TYPE_PREDICATE (seahorse_predicate_get_type ())
typedef struct _SeahorsePredicate SeahorsePredicate;
typedef enum  {
	SEAHORSE_USAGE_NONE = 0,
	SEAHORSE_USAGE_SYMMETRIC_KEY = 1,
	SEAHORSE_USAGE_PUBLIC_KEY = 2,
	SEAHORSE_USAGE_PRIVATE_KEY = 3,
	SEAHORSE_USAGE_CREDENTIALS = 4,
	SEAHORSE_USAGE_IDENTITY = 5,
	SEAHORSE_USAGE_OTHER = 10
} SeahorseUsage;

#define SEAHORSE_TYPE_USAGE (seahorse_usage_get_type ())
typedef enum  {
	SEAHORSE_FLAG_NONE = 0,
	SEAHORSE_FLAG_IS_VALID = 0x00000001,
	SEAHORSE_FLAG_CAN_ENCRYPT = 0x00000002,
	SEAHORSE_FLAG_CAN_SIGN = 0x00000004,
	SEAHORSE_FLAG_CAN_CERTIFY = 0x00000008,
	SEAHORSE_FLAG_CAN_AUTHENTICATE = 0x00000010,
	SEAHORSE_FLAG_EXPIRED = 0x00000100,
	SEAHORSE_FLAG_REVOKED = 0x00000200,
	SEAHORSE_FLAG_DISABLED = 0x00000400,
	SEAHORSE_FLAG_TRUSTED = 0x00001000,
	SEAHORSE_FLAG_PERSONAL = 0x00002000,
	SEAHORSE_FLAG_EXPORTABLE = 0x00100000,
	SEAHORSE_FLAG_DELETABLE = 0x10000000
} SeahorseFlags;

#define SEAHORSE_TYPE_FLAGS (seahorse_flags_get_type ())

struct _SeahorsePredicate {
	GType type;
	SeahorseUsage usage;
	SeahorseFlags flags;
	SeahorseFlags nflags;
	SeahorsePredicateFunc custom;
	void* custom_target;
};

GType seahorse_predicate_get_type (void) G_GNUC_CONST;
GType seahorse_usage_get_type (void) G_GNUC_CONST;
GType seahorse_flags_get_type (void) G_GNUC_CONST;
SeahorsePredicate* seahorse_predicate_dup (const SeahorsePredicate* self);
void seahorse_predicate_free (SeahorsePredicate* self);
gboolean seahorse_predicate_match (SeahorsePredicate *self,
                                   GObject* obj);

/**
     * Matches a seahorse object and a predicate
     *
     * @param obj The predicate to match
     *
     * @return false if predicate does not match the Object, true else
     */
gboolean
seahorse_predicate_match (SeahorsePredicate *self,
                          GObject* obj)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	SeahorseUsage _tmp2_;
	gboolean _tmp6_ = FALSE;
	SeahorseFlags _tmp7_;
	gboolean _tmp18_ = FALSE;
	SeahorsePredicateFunc _tmp19_;
#line 41 "../common/predicate.vala"
	g_return_val_if_fail (obj != NULL, FALSE);
#line 43 "../common/predicate.vala"
	if ((*self).type != ((GType) 0)) {
#line 103 "predicate.c"
		gboolean _tmp1_ = FALSE;
#line 43 "../common/predicate.vala"
		if (g_type_is_a (G_TYPE_FROM_INSTANCE (obj), (*self).type)) {
#line 43 "../common/predicate.vala"
			_tmp1_ = g_type_is_a ((*self).type, G_TYPE_FROM_INSTANCE (obj));
#line 109 "predicate.c"
		} else {
#line 43 "../common/predicate.vala"
			_tmp1_ = FALSE;
#line 113 "predicate.c"
		}
#line 43 "../common/predicate.vala"
		_tmp0_ = !_tmp1_;
#line 117 "predicate.c"
	} else {
#line 43 "../common/predicate.vala"
		_tmp0_ = FALSE;
#line 121 "predicate.c"
	}
#line 43 "../common/predicate.vala"
	if (_tmp0_) {
#line 44 "../common/predicate.vala"
		result = FALSE;
#line 44 "../common/predicate.vala"
		return result;
#line 129 "predicate.c"
	}
#line 46 "../common/predicate.vala"
	_tmp2_ = (*self).usage;
#line 46 "../common/predicate.vala"
	if (_tmp2_ != SEAHORSE_USAGE_NONE) {
#line 135 "predicate.c"
		SeahorseUsage obj_usage = 0;
		SeahorseUsage _tmp3_ = 0;
		SeahorseUsage _tmp4_;
		SeahorseUsage _tmp5_;
#line 47 "../common/predicate.vala"
		obj_usage = SEAHORSE_USAGE_NONE;
#line 48 "../common/predicate.vala"
		g_object_get (obj, "usage", &_tmp3_, NULL, NULL);
#line 48 "../common/predicate.vala"
		obj_usage = _tmp3_;
#line 50 "../common/predicate.vala"
		_tmp4_ = (*self).usage;
#line 50 "../common/predicate.vala"
		_tmp5_ = obj_usage;
#line 50 "../common/predicate.vala"
		if (_tmp4_ != _tmp5_) {
#line 51 "../common/predicate.vala"
			result = FALSE;
#line 51 "../common/predicate.vala"
			return result;
#line 156 "predicate.c"
		}
	}
#line 54 "../common/predicate.vala"
	_tmp7_ = (*self).flags;
#line 54 "../common/predicate.vala"
	if (_tmp7_ != 0) {
#line 54 "../common/predicate.vala"
		_tmp6_ = TRUE;
#line 165 "predicate.c"
	} else {
		SeahorseFlags _tmp8_;
#line 54 "../common/predicate.vala"
		_tmp8_ = (*self).nflags;
#line 54 "../common/predicate.vala"
		_tmp6_ = _tmp8_ != 0;
#line 172 "predicate.c"
	}
#line 54 "../common/predicate.vala"
	if (_tmp6_) {
#line 176 "predicate.c"
		SeahorseFlags obj_flags = 0;
		SeahorseFlags _tmp9_ = 0;
		gboolean _tmp10_ = FALSE;
		SeahorseFlags _tmp11_;
		gboolean _tmp14_ = FALSE;
		SeahorseFlags _tmp15_;
#line 55 "../common/predicate.vala"
		obj_flags = SEAHORSE_FLAG_NONE;
#line 56 "../common/predicate.vala"
		g_object_get (obj, "object-flags", &_tmp9_, NULL, NULL);
#line 56 "../common/predicate.vala"
		obj_flags = _tmp9_;
#line 58 "../common/predicate.vala"
		_tmp11_ = (*self).flags;
#line 58 "../common/predicate.vala"
		if (_tmp11_ != SEAHORSE_FLAG_NONE) {
#line 193 "predicate.c"
			SeahorseFlags _tmp12_;
			SeahorseFlags _tmp13_;
#line 58 "../common/predicate.vala"
			_tmp12_ = obj_flags;
#line 58 "../common/predicate.vala"
			_tmp13_ = (*self).flags;
#line 58 "../common/predicate.vala"
			_tmp10_ = (_tmp13_ & _tmp12_) == _tmp12_;
#line 202 "predicate.c"
		} else {
#line 58 "../common/predicate.vala"
			_tmp10_ = FALSE;
#line 206 "predicate.c"
		}
#line 58 "../common/predicate.vala"
		if (_tmp10_) {
#line 59 "../common/predicate.vala"
			result = FALSE;
#line 59 "../common/predicate.vala"
			return result;
#line 214 "predicate.c"
		}
#line 60 "../common/predicate.vala"
		_tmp15_ = (*self).nflags;
#line 60 "../common/predicate.vala"
		if (_tmp15_ != SEAHORSE_FLAG_NONE) {
#line 220 "predicate.c"
			SeahorseFlags _tmp16_;
			SeahorseFlags _tmp17_;
#line 60 "../common/predicate.vala"
			_tmp16_ = obj_flags;
#line 60 "../common/predicate.vala"
			_tmp17_ = (*self).nflags;
#line 60 "../common/predicate.vala"
			_tmp14_ = !((_tmp17_ & _tmp16_) == _tmp16_);
#line 229 "predicate.c"
		} else {
#line 60 "../common/predicate.vala"
			_tmp14_ = FALSE;
#line 233 "predicate.c"
		}
#line 60 "../common/predicate.vala"
		if (_tmp14_) {
#line 61 "../common/predicate.vala"
			result = FALSE;
#line 61 "../common/predicate.vala"
			return result;
#line 241 "predicate.c"
		}
	}
#line 65 "../common/predicate.vala"
	_tmp19_ = (*self).custom;
#line 65 "../common/predicate.vala"
	if (_tmp19_ != NULL) {
#line 248 "predicate.c"
		SeahorsePredicateFunc _tmp20_;
		void* _tmp21_;
#line 65 "../common/predicate.vala"
		_tmp20_ = (*self).custom;
#line 65 "../common/predicate.vala"
		_tmp21_ = (*self).custom_target;
#line 65 "../common/predicate.vala"
		_tmp18_ = !_tmp20_ (obj, _tmp21_);
#line 257 "predicate.c"
	} else {
#line 65 "../common/predicate.vala"
		_tmp18_ = FALSE;
#line 261 "predicate.c"
	}
#line 65 "../common/predicate.vala"
	if (_tmp18_) {
#line 66 "../common/predicate.vala"
		result = FALSE;
#line 66 "../common/predicate.vala"
		return result;
#line 269 "predicate.c"
	}
#line 68 "../common/predicate.vala"
	result = TRUE;
#line 68 "../common/predicate.vala"
	return result;
#line 275 "predicate.c"
}

SeahorsePredicate*
seahorse_predicate_dup (const SeahorsePredicate* self)
{
	SeahorsePredicate* dup;
#line 26 "../common/predicate.vala"
	dup = g_new0 (SeahorsePredicate, 1);
#line 26 "../common/predicate.vala"
	memcpy (dup, self, sizeof (SeahorsePredicate));
#line 26 "../common/predicate.vala"
	return dup;
#line 288 "predicate.c"
}

void
seahorse_predicate_free (SeahorsePredicate* self)
{
#line 26 "../common/predicate.vala"
	g_free (self);
#line 296 "predicate.c"
}

GType
seahorse_predicate_get_type (void)
{
	static volatile gsize seahorse_predicate_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_predicate_type_id__volatile)) {
		GType seahorse_predicate_type_id;
		seahorse_predicate_type_id = g_boxed_type_register_static ("SeahorsePredicate", (GBoxedCopyFunc) seahorse_predicate_dup, (GBoxedFreeFunc) seahorse_predicate_free);
		g_once_init_leave (&seahorse_predicate_type_id__volatile, seahorse_predicate_type_id);
	}
	return seahorse_predicate_type_id__volatile;
}

