/* application.c generated by valac 0.44.0, the Vala compiler
 * generated from application.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2005, 2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 * Copyright (C) 2018 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include "seahorse-common.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "seahorse-gkr.h"
#include "seahorse-ssh.h"
#include "pgp/seahorse-pgp-backend.h"
#include "pkcs11/seahorse-pkcs11-backend.h"
#include "config.h"

#define SEAHORSE_TYPE_APPLICATION (seahorse_application_get_type ())
#define SEAHORSE_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_APPLICATION, SeahorseApplication))
#define SEAHORSE_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_APPLICATION, SeahorseApplicationClass))
#define SEAHORSE_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_APPLICATION))
#define SEAHORSE_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_APPLICATION))
#define SEAHORSE_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_APPLICATION, SeahorseApplicationClass))

typedef struct _SeahorseApplication SeahorseApplication;
typedef struct _SeahorseApplicationClass SeahorseApplicationClass;
typedef struct _SeahorseApplicationPrivate SeahorseApplicationPrivate;

#define SEAHORSE_TYPE_SEARCH_PROVIDER (seahorse_search_provider_get_type ())
#define SEAHORSE_SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_SEARCH_PROVIDER, SeahorseSearchProvider))
#define SEAHORSE_SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_SEARCH_PROVIDER, SeahorseSearchProviderClass))
#define SEAHORSE_IS_SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_SEARCH_PROVIDER))
#define SEAHORSE_IS_SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_SEARCH_PROVIDER))
#define SEAHORSE_SEARCH_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_SEARCH_PROVIDER, SeahorseSearchProviderClass))

typedef struct _SeahorseSearchProvider SeahorseSearchProvider;
typedef struct _SeahorseSearchProviderClass SeahorseSearchProviderClass;

#define SEAHORSE_TYPE_KEY_MANAGER (seahorse_key_manager_get_type ())
#define SEAHORSE_KEY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_KEY_MANAGER, SeahorseKeyManager))
#define SEAHORSE_KEY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_KEY_MANAGER, SeahorseKeyManagerClass))
#define SEAHORSE_IS_KEY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_KEY_MANAGER))
#define SEAHORSE_IS_KEY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_KEY_MANAGER))
#define SEAHORSE_KEY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_KEY_MANAGER, SeahorseKeyManagerClass))

typedef struct _SeahorseKeyManager SeahorseKeyManager;
typedef struct _SeahorseKeyManagerClass SeahorseKeyManagerClass;
enum  {
	SEAHORSE_APPLICATION_0_PROPERTY,
	SEAHORSE_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* seahorse_application_properties[SEAHORSE_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SeahorseApplication {
	GtkApplication parent_instance;
	SeahorseApplicationPrivate * priv;
};

struct _SeahorseApplicationClass {
	GtkApplicationClass parent_class;
};

struct _SeahorseApplicationPrivate {
	SeahorseSearchProvider* search_provider;
	guint search_provider_dbus_id;
	SeahorseKeyManager* key_mgr;
};

struct _Block1Data {
	int _ref_count_;
	SeahorseApplication* self;
	GtkAboutDialog* about;
};

static gint SeahorseApplication_private_offset;
static gpointer seahorse_application_parent_class = NULL;

GType seahorse_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseApplication, g_object_unref)
GType seahorse_search_provider_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseSearchProvider, g_object_unref)
guint seahorse_search_provider_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
GType seahorse_key_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseKeyManager, g_object_unref)
static void _g_application_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static void seahorse_application_on_app_help (SeahorseApplication* self,
                                       GSimpleAction* action,
                                       GVariant* param);
static void _seahorse_application_on_app_help_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void seahorse_application_on_app_about (SeahorseApplication* self,
                                        GSimpleAction* action,
                                        GVariant* param);
static void _seahorse_application_on_app_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void seahorse_application_on_app_preferences (SeahorseApplication* self,
                                              GSimpleAction* action,
                                              GVariant* param);
static void _seahorse_application_on_app_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
SeahorseApplication* seahorse_application_new (void);
SeahorseApplication* seahorse_application_construct (GType object_type);
SeahorseSearchProvider* seahorse_search_provider_new (GApplication* app);
SeahorseSearchProvider* seahorse_search_provider_construct (GType object_type,
                                                            GApplication* app);
static void seahorse_application_add_action_accelerators (SeahorseApplication* self);
static void seahorse_application_real_startup (GApplication* base);
static void seahorse_application_real_activate (GApplication* base);
SeahorseKeyManager* seahorse_key_manager_new (SeahorseApplication* app);
SeahorseKeyManager* seahorse_key_manager_construct (GType object_type,
                                                    SeahorseApplication* app);
static gint seahorse_application_real_handle_local_options (GApplication* base,
                                                     GVariantDict* options);
static gboolean seahorse_application_real_dbus_register (GApplication* base,
                                                  GDBusConnection* connection,
                                                  const gchar* object_path,
                                                  GError** error);
static void seahorse_application_real_dbus_unregister (GApplication* base,
                                                GDBusConnection* connection,
                                                const gchar* object_path);
void seahorse_application_initialize_search (SeahorseApplication* self);
void seahorse_search_provider_load (SeahorseSearchProvider* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
void seahorse_search_provider_load_finish (SeahorseSearchProvider* self,
                                           GAsyncResult* _res_,
                                           GError** error);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda30_ (Block1Data* _data1_,
                  gint response);
static void ___lambda30__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void seahorse_application_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gchar* SEAHORSE_APPLICATION_AUTHORS[11] = {"Jacob Perkins <jap1@users.sourceforge.net>", "Jose Carlos Garcia Sogo <jsogo@users.sourceforge.net>", "Jean Schurger <yshark@schurger.org>", "Stef Walter <stef@memberwebs.com>", "Adam Schreiber <sadam@clemson.edu>", "Niels De Graef <nielsdegraef@gmail.com>", "", N_ ("Contributions:"), "Albrecht Dreß <albrecht.dress@arcor.de>", "Jim Pharis <binbrain@gmail.com>", NULL};
static const gchar* SEAHORSE_APPLICATION_DOCUMENTERS[4] = {"Jacob Perkins <jap1@users.sourceforge.net>", "Adam Schreiber <sadam@clemson.edu>", "Milo Casagrande <milo_casagrande@yahoo.it>", NULL};
static const gchar* SEAHORSE_APPLICATION_ARTISTS[3] = {"Jacob Perkins <jap1@users.sourceforge.net>", "Stef Walter <stef@memberwebs.com>", NULL};
static const GActionEntry SEAHORSE_APPLICATION_action_entries[4] = {{"quit", _g_application_quit_gsimple_action_activate_callback}, {"help", _seahorse_application_on_app_help_gsimple_action_activate_callback}, {"about", _seahorse_application_on_app_about_gsimple_action_activate_callback}, {"preferences", _seahorse_application_on_app_preferences_gsimple_action_activate_callback}};
static const GOptionEntry SEAHORSE_APPLICATION_cmd_options[2] = {{"version", 'v', 0, G_OPTION_ARG_NONE, NULL, N_ ("Version of this application"), NULL}, {NULL}};

static inline gpointer
seahorse_application_get_instance_private (SeahorseApplication* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseApplication_private_offset);
}

static void
_g_application_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 57 "../src/application.vala"
	g_application_quit ((GApplication*) self);
#line 197 "application.c"
}

static void
_seahorse_application_on_app_help_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 57 "../src/application.vala"
	seahorse_application_on_app_help ((SeahorseApplication*) self, action, parameter);
#line 207 "application.c"
}

static void
_seahorse_application_on_app_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 57 "../src/application.vala"
	seahorse_application_on_app_about ((SeahorseApplication*) self, action, parameter);
#line 217 "application.c"
}

static void
_seahorse_application_on_app_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 57 "../src/application.vala"
	seahorse_application_on_app_preferences ((SeahorseApplication*) self, action, parameter);
#line 227 "application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "../src/application.vala"
	return self ? g_object_ref (self) : NULL;
#line 235 "application.c"
}

SeahorseApplication*
seahorse_application_construct (GType object_type)
{
	SeahorseApplication * self = NULL;
	SeahorseSearchProvider* _tmp0_;
	GSimpleAction* pref_action = NULL;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
#line 70 "../src/application.vala"
	self = (SeahorseApplication*) g_object_new (object_type, "application-id", "org.gnome.seahorse.Application", "flags", G_APPLICATION_FLAGS_NONE, NULL);
#line 74 "../src/application.vala"
	_tmp0_ = seahorse_search_provider_new ((GApplication*) self);
#line 74 "../src/application.vala"
	_g_object_unref0 (self->priv->search_provider);
#line 74 "../src/application.vala"
	self->priv->search_provider = _tmp0_;
#line 76 "../src/application.vala"
	g_action_map_add_action_entries ((GActionMap*) self, SEAHORSE_APPLICATION_action_entries, (gint) G_N_ELEMENTS (SEAHORSE_APPLICATION_action_entries), self);
#line 77 "../src/application.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) self, "preferences");
#line 77 "../src/application.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp1_) : NULL);
#line 77 "../src/application.vala"
	pref_action = _tmp2_;
#line 78 "../src/application.vala"
	g_simple_action_set_enabled (pref_action, seahorse_prefs_available ());
#line 79 "../src/application.vala"
	seahorse_application_add_action_accelerators (self);
#line 81 "../src/application.vala"
	g_application_add_main_option_entries ((GApplication*) self, SEAHORSE_APPLICATION_cmd_options);
#line 69 "../src/application.vala"
	_g_object_unref0 (pref_action);
#line 69 "../src/application.vala"
	return self;
#line 272 "application.c"
}

SeahorseApplication*
seahorse_application_new (void)
{
#line 69 "../src/application.vala"
	return seahorse_application_construct (SEAHORSE_TYPE_APPLICATION);
#line 280 "application.c"
}

static void
seahorse_application_add_action_accelerators (SeahorseApplication* self)
{
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
#line 84 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/application.vala"
	_tmp0_ = g_strdup ("F1");
#line 85 "../src/application.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 85 "../src/application.vala"
	_tmp1_[0] = _tmp0_;
#line 85 "../src/application.vala"
	_tmp2_ = _tmp1_;
#line 85 "../src/application.vala"
	_tmp2__length1 = 1;
#line 85 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.help", _tmp2_);
#line 85 "../src/application.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 86 "../src/application.vala"
	_tmp3_ = g_strdup ("<control>Q");
#line 86 "../src/application.vala"
	_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 86 "../src/application.vala"
	_tmp4_[0] = _tmp3_;
#line 86 "../src/application.vala"
	_tmp5_ = _tmp4_;
#line 86 "../src/application.vala"
	_tmp5__length1 = 1;
#line 86 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.quit", _tmp5_);
#line 86 "../src/application.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 88 "../src/application.vala"
	_tmp6_ = g_strdup ("<control>F");
#line 88 "../src/application.vala"
	_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 88 "../src/application.vala"
	_tmp7_[0] = _tmp6_;
#line 88 "../src/application.vala"
	_tmp8_ = _tmp7_;
#line 88 "../src/application.vala"
	_tmp8__length1 = 1;
#line 88 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.show-search", _tmp8_);
#line 88 "../src/application.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 89 "../src/application.vala"
	_tmp9_ = g_strdup ("<control>N");
#line 89 "../src/application.vala"
	_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 89 "../src/application.vala"
	_tmp10_[0] = _tmp9_;
#line 89 "../src/application.vala"
	_tmp11_ = _tmp10_;
#line 89 "../src/application.vala"
	_tmp11__length1 = 1;
#line 89 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.new-item", _tmp11_);
#line 89 "../src/application.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 90 "../src/application.vala"
	_tmp12_ = g_strdup ("<control>I");
#line 90 "../src/application.vala"
	_tmp13_ = g_new0 (gchar*, 1 + 1);
#line 90 "../src/application.vala"
	_tmp13_[0] = _tmp12_;
#line 90 "../src/application.vala"
	_tmp14_ = _tmp13_;
#line 90 "../src/application.vala"
	_tmp14__length1 = 1;
#line 90 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.import-file", _tmp14_);
#line 90 "../src/application.vala"
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
#line 91 "../src/application.vala"
	_tmp15_ = g_strdup ("<control>C");
#line 91 "../src/application.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 91 "../src/application.vala"
	_tmp16_[0] = _tmp15_;
#line 91 "../src/application.vala"
	_tmp17_ = _tmp16_;
#line 91 "../src/application.vala"
	_tmp17__length1 = 1;
#line 91 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.copy", _tmp17_);
#line 91 "../src/application.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 92 "../src/application.vala"
	_tmp18_ = g_strdup ("<control>V");
#line 92 "../src/application.vala"
	_tmp19_ = g_new0 (gchar*, 1 + 1);
#line 92 "../src/application.vala"
	_tmp19_[0] = _tmp18_;
#line 92 "../src/application.vala"
	_tmp20_ = _tmp19_;
#line 92 "../src/application.vala"
	_tmp20__length1 = 1;
#line 92 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.paste", _tmp20_);
#line 92 "../src/application.vala"
	_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 414 "application.c"
}

static void
seahorse_application_real_startup (GApplication* base)
{
	SeahorseApplication * self;
#line 95 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 96 "../src/application.vala"
	G_APPLICATION_CLASS (seahorse_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 99 "../src/application.vala"
	seahorse_icons_init ();
#line 102 "../src/application.vala"
	seahorse_gkr_backend_initialize ();
#line 103 "../src/application.vala"
	seahorse_ssh_backend_initialize ();
#line 105 "../src/application.vala"
	seahorse_pgp_backend_initialize ();
#line 108 "../src/application.vala"
	seahorse_pkcs11_backend_initialize ();
#line 435 "application.c"
}

static void
seahorse_application_real_activate (GApplication* base)
{
	SeahorseApplication * self;
	GtkWindow* _tmp0_;
	SeahorseKeyManager* _tmp2_;
#line 112 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 113 "../src/application.vala"
	_tmp0_ = gtk_application_get_active_window ((GtkApplication*) self);
#line 113 "../src/application.vala"
	if (_tmp0_ == NULL) {
#line 450 "application.c"
		SeahorseKeyManager* _tmp1_;
#line 114 "../src/application.vala"
		_tmp1_ = seahorse_key_manager_new (self);
#line 114 "../src/application.vala"
		g_object_ref_sink (_tmp1_);
#line 114 "../src/application.vala"
		_g_object_unref0 (self->priv->key_mgr);
#line 114 "../src/application.vala"
		self->priv->key_mgr = _tmp1_;
#line 460 "application.c"
	}
#line 116 "../src/application.vala"
	_tmp2_ = self->priv->key_mgr;
#line 116 "../src/application.vala"
	gtk_window_present ((GtkWindow*) _tmp2_);
#line 466 "application.c"
}

static gint
seahorse_application_real_handle_local_options (GApplication* base,
                                                GVariantDict* options)
{
	SeahorseApplication * self;
	gint result = 0;
#line 119 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 119 "../src/application.vala"
	g_return_val_if_fail (options != NULL, 0);
#line 120 "../src/application.vala"
	if (g_variant_dict_contains (options, "version")) {
#line 121 "../src/application.vala"
		g_print ("%s\n", PACKAGE_STRING);
#line 123 "../src/application.vala"
		g_print ("GNUPG: %s (%d.%d.%d)\n", GNUPG, GPG_MAJOR, GPG_MINOR, GPG_MICRO);
#line 125 "../src/application.vala"
		result = 0;
#line 125 "../src/application.vala"
		return result;
#line 489 "application.c"
	}
#line 128 "../src/application.vala"
	result = -1;
#line 128 "../src/application.vala"
	return result;
#line 495 "application.c"
}

static gboolean
seahorse_application_real_dbus_register (GApplication* base,
                                         GDBusConnection* connection,
                                         const gchar* object_path,
                                         GError** error)
{
	SeahorseApplication * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint _tmp2_ = 0U;
	SeahorseSearchProvider* _tmp3_;
	guint _tmp4_;
	GError* _inner_error0_ = NULL;
#line 131 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 131 "../src/application.vala"
	g_return_val_if_fail (connection != NULL, FALSE);
#line 131 "../src/application.vala"
	g_return_val_if_fail (object_path != NULL, FALSE);
#line 132 "../src/application.vala"
	_tmp0_ = G_APPLICATION_CLASS (seahorse_application_parent_class)->dbus_register ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), connection, object_path, &_inner_error0_);
#line 132 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 521 "application.c"
		gboolean _tmp1_ = FALSE;
#line 132 "../src/application.vala"
		g_propagate_error (error, _inner_error0_);
#line 132 "../src/application.vala"
		return _tmp1_;
#line 527 "application.c"
	}
#line 132 "../src/application.vala"
	if (!_tmp0_) {
#line 133 "../src/application.vala"
		result = FALSE;
#line 133 "../src/application.vala"
		return result;
#line 535 "application.c"
	}
#line 135 "../src/application.vala"
	_tmp3_ = self->priv->search_provider;
#line 135 "../src/application.vala"
	_tmp4_ = seahorse_search_provider_register_object (_tmp3_, connection, object_path, &_inner_error0_);
#line 135 "../src/application.vala"
	_tmp2_ = _tmp4_;
#line 135 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 545 "application.c"
		gboolean _tmp5_ = FALSE;
#line 135 "../src/application.vala"
		g_propagate_error (error, _inner_error0_);
#line 135 "../src/application.vala"
		return _tmp5_;
#line 551 "application.c"
	}
#line 135 "../src/application.vala"
	self->priv->search_provider_dbus_id = _tmp2_;
#line 136 "../src/application.vala"
	result = TRUE;
#line 136 "../src/application.vala"
	return result;
#line 559 "application.c"
}

static void
seahorse_application_real_dbus_unregister (GApplication* base,
                                           GDBusConnection* connection,
                                           const gchar* object_path)
{
	SeahorseApplication * self;
#line 139 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 139 "../src/application.vala"
	g_return_if_fail (connection != NULL);
#line 139 "../src/application.vala"
	g_return_if_fail (object_path != NULL);
#line 140 "../src/application.vala"
	if (self->priv->search_provider_dbus_id != ((guint) 0)) {
#line 141 "../src/application.vala"
		g_dbus_connection_unregister_object (connection, self->priv->search_provider_dbus_id);
#line 142 "../src/application.vala"
		self->priv->search_provider_dbus_id = (guint) 0;
#line 580 "application.c"
	}
#line 145 "../src/application.vala"
	G_APPLICATION_CLASS (seahorse_application_parent_class)->dbus_unregister ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), connection, object_path);
#line 584 "application.c"
}

void
seahorse_application_initialize_search (SeahorseApplication* self)
{
	SeahorseSearchProvider* _tmp0_;
#line 148 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/application.vala"
	_tmp0_ = self->priv->search_provider;
#line 149 "../src/application.vala"
	seahorse_search_provider_load (_tmp0_, NULL, NULL);
#line 597 "application.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 152 "../src/application.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 152 "../src/application.vala"
	return _data1_;
#line 607 "application.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 152 "../src/application.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 617 "application.c"
		SeahorseApplication* self;
#line 152 "../src/application.vala"
		self = _data1_->self;
#line 152 "../src/application.vala"
		_g_object_unref0 (_data1_->about);
#line 152 "../src/application.vala"
		_g_object_unref0 (self);
#line 152 "../src/application.vala"
		g_slice_free (Block1Data, _data1_);
#line 627 "application.c"
	}
}

static void
__lambda30_ (Block1Data* _data1_,
             gint response)
{
	SeahorseApplication* self;
#line 165 "../src/application.vala"
	self = _data1_->self;
#line 166 "../src/application.vala"
	gtk_widget_hide ((GtkWidget*) _data1_->about);
#line 640 "application.c"
}

static void
___lambda30__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 165 "../src/application.vala"
	__lambda30_ (self, response_id);
#line 650 "application.c"
}

static void
seahorse_application_on_app_about (SeahorseApplication* self,
                                   GSimpleAction* action,
                                   GVariant* param)
{
	Block1Data* _data1_;
	GtkAboutDialog* _tmp0_;
	SeahorseKeyManager* _tmp1_;
#line 152 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/application.vala"
	g_return_if_fail (action != NULL);
#line 152 "../src/application.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 152 "../src/application.vala"
	_data1_->_ref_count_ = 1;
#line 152 "../src/application.vala"
	_data1_->self = g_object_ref (self);
#line 153 "../src/application.vala"
	_tmp0_ = (GtkAboutDialog*) gtk_about_dialog_new ();
#line 153 "../src/application.vala"
	g_object_ref_sink (_tmp0_);
#line 153 "../src/application.vala"
	_data1_->about = _tmp0_;
#line 154 "../src/application.vala"
	gtk_about_dialog_set_artists (_data1_->about, SEAHORSE_APPLICATION_ARTISTS);
#line 155 "../src/application.vala"
	gtk_about_dialog_set_authors (_data1_->about, SEAHORSE_APPLICATION_AUTHORS);
#line 156 "../src/application.vala"
	gtk_about_dialog_set_documenters (_data1_->about, SEAHORSE_APPLICATION_DOCUMENTERS);
#line 157 "../src/application.vala"
	gtk_about_dialog_set_version (_data1_->about, VERSION);
#line 158 "../src/application.vala"
	gtk_about_dialog_set_comments (_data1_->about, _ ("Passwords and Keys"));
#line 159 "../src/application.vala"
	gtk_about_dialog_set_copyright (_data1_->about, "© 2002 - 2018 Seahorse Contributors");
#line 160 "../src/application.vala"
	gtk_about_dialog_set_translator_credits (_data1_->about, _ ("translator-credits"));
#line 161 "../src/application.vala"
	gtk_about_dialog_set_logo_icon_name (_data1_->about, "org.gnome.seahorse.Application");
#line 162 "../src/application.vala"
	gtk_about_dialog_set_website (_data1_->about, "https://wiki.gnome.org/Apps/Seahorse");
#line 163 "../src/application.vala"
	gtk_about_dialog_set_website_label (_data1_->about, _ ("Seahorse Project Homepage"));
#line 165 "../src/application.vala"
	g_signal_connect_data ((GtkDialog*) _data1_->about, "response", (GCallback) ___lambda30__gtk_dialog_response, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 169 "../src/application.vala"
	_tmp1_ = self->priv->key_mgr;
#line 169 "../src/application.vala"
	gtk_window_set_transient_for ((GtkWindow*) _data1_->about, (GtkWindow*) _tmp1_);
#line 170 "../src/application.vala"
	gtk_dialog_run ((GtkDialog*) _data1_->about);
#line 171 "../src/application.vala"
	gtk_widget_destroy ((GtkWidget*) _data1_->about);
#line 152 "../src/application.vala"
	block1_data_unref (_data1_);
#line 152 "../src/application.vala"
	_data1_ = NULL;
#line 711 "application.c"
}

static void
seahorse_application_on_app_help (SeahorseApplication* self,
                                  GSimpleAction* action,
                                  GVariant* param)
{
	GError* _inner_error0_ = NULL;
#line 174 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 174 "../src/application.vala"
	g_return_if_fail (action != NULL);
#line 724 "application.c"
	{
		SeahorseKeyManager* _tmp0_;
#line 176 "../src/application.vala"
		_tmp0_ = self->priv->key_mgr;
#line 176 "../src/application.vala"
		gtk_show_uri_on_window ((GtkWindow*) _tmp0_, "help:seahorse", gtk_get_current_event_time (), &_inner_error0_);
#line 176 "../src/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 733 "application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 175 "../src/application.vala"
		err = _inner_error0_;
#line 175 "../src/application.vala"
		_inner_error0_ = NULL;
#line 178 "../src/application.vala"
		_tmp1_ = err;
#line 178 "../src/application.vala"
		_tmp2_ = _tmp1_->message;
#line 178 "../src/application.vala"
		g_warning ("application.vala:178: Error showing help: %s", _tmp2_);
#line 175 "../src/application.vala"
		_g_error_free0 (err);
#line 755 "application.c"
	}
	__finally0:
#line 175 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 175 "../src/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 175 "../src/application.vala"
		g_clear_error (&_inner_error0_);
#line 175 "../src/application.vala"
		return;
#line 766 "application.c"
	}
}

static void
seahorse_application_on_app_preferences (SeahorseApplication* self,
                                         GSimpleAction* action,
                                         GVariant* param)
{
	SeahorsePrefs* prefs_dialog = NULL;
	SeahorseKeyManager* _tmp0_;
	SeahorsePrefs* _tmp1_;
#line 182 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/application.vala"
	g_return_if_fail (action != NULL);
#line 183 "../src/application.vala"
	_tmp0_ = self->priv->key_mgr;
#line 183 "../src/application.vala"
	_tmp1_ = seahorse_prefs_new ((GtkWindow*) _tmp0_, NULL);
#line 183 "../src/application.vala"
	g_object_ref_sink (_tmp1_);
#line 183 "../src/application.vala"
	prefs_dialog = _tmp1_;
#line 184 "../src/application.vala"
	gtk_dialog_run ((GtkDialog*) prefs_dialog);
#line 185 "../src/application.vala"
	gtk_widget_destroy ((GtkWidget*) prefs_dialog);
#line 182 "../src/application.vala"
	_g_object_unref0 (prefs_dialog);
#line 796 "application.c"
}

static void
seahorse_application_class_init (SeahorseApplicationClass * klass,
                                 gpointer klass_data)
{
#line 24 "../src/application.vala"
	seahorse_application_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/application.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseApplication_private_offset);
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) seahorse_application_real_startup;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) seahorse_application_real_activate;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->handle_local_options = (gint (*) (GApplication*, GVariantDict*)) seahorse_application_real_handle_local_options;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->dbus_register = (gboolean (*) (GApplication*, GDBusConnection*, const gchar*, GError**)) seahorse_application_real_dbus_register;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->dbus_unregister = (void (*) (GApplication*, GDBusConnection*, const gchar*)) seahorse_application_real_dbus_unregister;
#line 24 "../src/application.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_application_finalize;
#line 819 "application.c"
}

static void
seahorse_application_instance_init (SeahorseApplication * self,
                                    gpointer klass)
{
#line 24 "../src/application.vala"
	self->priv = seahorse_application_get_instance_private (self);
#line 26 "../src/application.vala"
	self->priv->search_provider_dbus_id = (guint) 0;
#line 28 "../src/application.vala"
	self->priv->key_mgr = NULL;
#line 832 "application.c"
}

static void
seahorse_application_finalize (GObject * obj)
{
	SeahorseApplication * self;
#line 24 "../src/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_APPLICATION, SeahorseApplication);
#line 25 "../src/application.vala"
	_g_object_unref0 (self->priv->search_provider);
#line 28 "../src/application.vala"
	_g_object_unref0 (self->priv->key_mgr);
#line 24 "../src/application.vala"
	G_OBJECT_CLASS (seahorse_application_parent_class)->finalize (obj);
#line 847 "application.c"
}

GType
seahorse_application_get_type (void)
{
	static volatile gsize seahorse_application_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_application_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseApplication), 0, (GInstanceInitFunc) seahorse_application_instance_init, NULL };
		GType seahorse_application_type_id;
		seahorse_application_type_id = g_type_register_static (gtk_application_get_type (), "SeahorseApplication", &g_define_type_info, 0);
		SeahorseApplication_private_offset = g_type_add_instance_private (seahorse_application_type_id, sizeof (SeahorseApplicationPrivate));
		g_once_init_leave (&seahorse_application_type_id__volatile, seahorse_application_type_id);
	}
	return seahorse_application_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

