/* algorithm.c generated by valac 0.44.0, the Vala compiler
 * generated from algorithm.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (c) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

typedef enum  {
	SEAHORSE_SSH_ALGORITHM_UNKNOWN,
	SEAHORSE_SSH_ALGORITHM_RSA,
	SEAHORSE_SSH_ALGORITHM_DSA,
	SEAHORSE_SSH_ALGORITHM_ECDSA,
	SEAHORSE_SSH_ALGORITHM_ED25519
} SeahorseSshAlgorithm;

#define SEAHORSE_SSH_TYPE_ALGORITHM (seahorse_ssh_algorithm_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

GType seahorse_ssh_algorithm_get_type (void) G_GNUC_CONST;
gchar* seahorse_ssh_algorithm_to_string (SeahorseSshAlgorithm self);
SeahorseSshAlgorithm seahorse_ssh_algorithm_from_string (const gchar* type);
SeahorseSshAlgorithm seahorse_ssh_algorithm_guess_from_string (const gchar* str);

/**
     * Returns a (non-localized) string representation.
     *
     * @return A string representation, or null if UNKNOWN.
     */
gchar*
seahorse_ssh_algorithm_to_string (SeahorseSshAlgorithm self)
{
	gchar* result = NULL;
#line 37 "../ssh/algorithm.vala"
	switch (self) {
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_UNKNOWN:
#line 58 "algorithm.c"
		{
			gchar* _tmp0_;
#line 39 "../ssh/algorithm.vala"
			_tmp0_ = g_strdup ("");
#line 39 "../ssh/algorithm.vala"
			result = _tmp0_;
#line 39 "../ssh/algorithm.vala"
			return result;
#line 67 "algorithm.c"
		}
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_RSA:
#line 71 "algorithm.c"
		{
			gchar* _tmp1_;
#line 41 "../ssh/algorithm.vala"
			_tmp1_ = g_strdup ("RSA");
#line 41 "../ssh/algorithm.vala"
			result = _tmp1_;
#line 41 "../ssh/algorithm.vala"
			return result;
#line 80 "algorithm.c"
		}
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_DSA:
#line 84 "algorithm.c"
		{
			gchar* _tmp2_;
#line 43 "../ssh/algorithm.vala"
			_tmp2_ = g_strdup ("DSA");
#line 43 "../ssh/algorithm.vala"
			result = _tmp2_;
#line 43 "../ssh/algorithm.vala"
			return result;
#line 93 "algorithm.c"
		}
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_ECDSA:
#line 97 "algorithm.c"
		{
			gchar* _tmp3_;
#line 45 "../ssh/algorithm.vala"
			_tmp3_ = g_strdup ("ECDSA");
#line 45 "../ssh/algorithm.vala"
			result = _tmp3_;
#line 45 "../ssh/algorithm.vala"
			return result;
#line 106 "algorithm.c"
		}
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_ED25519:
#line 110 "algorithm.c"
		{
			gchar* _tmp4_;
#line 47 "../ssh/algorithm.vala"
			_tmp4_ = g_strdup ("ED25519");
#line 47 "../ssh/algorithm.vala"
			result = _tmp4_;
#line 47 "../ssh/algorithm.vala"
			return result;
#line 119 "algorithm.c"
		}
		default:
		{
#line 49 "../ssh/algorithm.vala"
			g_assert_not_reached ();
#line 125 "algorithm.c"
		}
	}
}

/**
     * Converts a string representation into a Algorithm.
     *
     * @return The algorithm (can be UNKNOWN).
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 156 "algorithm.c"
}

SeahorseSshAlgorithm
seahorse_ssh_algorithm_from_string (const gchar* type)
{
	SeahorseSshAlgorithm result = 0;
	gboolean _tmp0_ = FALSE;
	gchar* _type = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GQuark _tmp8_ = 0U;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label0 = 0;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label1 = 0;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label2 = 0;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label3 = 0;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label4 = 0;
#line 59 "../ssh/algorithm.vala"
	if (type == NULL) {
#line 59 "../ssh/algorithm.vala"
		_tmp0_ = TRUE;
#line 186 "algorithm.c"
	} else {
#line 59 "../ssh/algorithm.vala"
		_tmp0_ = g_strcmp0 (type, "") == 0;
#line 190 "algorithm.c"
	}
#line 59 "../ssh/algorithm.vala"
	if (_tmp0_) {
#line 60 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_UNKNOWN;
#line 60 "../ssh/algorithm.vala"
		return result;
#line 198 "algorithm.c"
	}
#line 62 "../ssh/algorithm.vala"
	_tmp1_ = string_strip (type);
#line 62 "../ssh/algorithm.vala"
	_tmp2_ = _tmp1_;
#line 62 "../ssh/algorithm.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 62 "../ssh/algorithm.vala"
	_tmp4_ = _tmp3_;
#line 62 "../ssh/algorithm.vala"
	_g_free0 (_tmp2_);
#line 62 "../ssh/algorithm.vala"
	_type = _tmp4_;
#line 63 "../ssh/algorithm.vala"
	_tmp5_ = _type;
#line 63 "../ssh/algorithm.vala"
	_tmp6_ = _tmp5_;
#line 63 "../ssh/algorithm.vala"
	_tmp8_ = (NULL == _tmp6_) ? 0 : g_quark_from_string (_tmp6_);
#line 63 "../ssh/algorithm.vala"
	if (_tmp8_ == ((0 != _tmp7_label0) ? _tmp7_label0 : (_tmp7_label0 = g_quark_from_static_string ("rsa")))) {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 222 "algorithm.c"
			default:
			{
#line 65 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_RSA;
#line 65 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 65 "../ssh/algorithm.vala"
				return result;
#line 231 "algorithm.c"
			}
		}
	} else if ((_tmp8_ == ((0 != _tmp7_label1) ? _tmp7_label1 : (_tmp7_label1 = g_quark_from_static_string ("dsa")))) || (_tmp8_ == ((0 != _tmp7_label2) ? _tmp7_label2 : (_tmp7_label2 = g_quark_from_static_string ("dss"))))) {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 237 "algorithm.c"
			default:
			{
#line 68 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_DSA;
#line 68 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 68 "../ssh/algorithm.vala"
				return result;
#line 246 "algorithm.c"
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label3) ? _tmp7_label3 : (_tmp7_label3 = g_quark_from_static_string ("ecdsa")))) {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 252 "algorithm.c"
			default:
			{
#line 70 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_ECDSA;
#line 70 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 70 "../ssh/algorithm.vala"
				return result;
#line 261 "algorithm.c"
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label4) ? _tmp7_label4 : (_tmp7_label4 = g_quark_from_static_string ("ed25519")))) {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 267 "algorithm.c"
			default:
			{
#line 72 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_ED25519;
#line 72 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 72 "../ssh/algorithm.vala"
				return result;
#line 276 "algorithm.c"
			}
		}
	} else {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 282 "algorithm.c"
			default:
			{
#line 74 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_UNKNOWN;
#line 74 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 74 "../ssh/algorithm.vala"
				return result;
#line 291 "algorithm.c"
			}
		}
	}
#line 58 "../ssh/algorithm.vala"
	_g_free0 (_type);
#line 297 "algorithm.c"
}

/**
     * Tries to make an educated guess for the algorithm type.
     * Basically it just checks if the given string contains the type.
     *
     * @return The guessed algorithm (can be UNKNOWN)
     */
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 322 "algorithm.c"
}

SeahorseSshAlgorithm
seahorse_ssh_algorithm_guess_from_string (const gchar* str)
{
	SeahorseSshAlgorithm result = 0;
	gboolean _tmp0_ = FALSE;
	gchar* str_down = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 85 "../ssh/algorithm.vala"
	if (str == NULL) {
#line 85 "../ssh/algorithm.vala"
		_tmp0_ = TRUE;
#line 341 "algorithm.c"
	} else {
#line 85 "../ssh/algorithm.vala"
		_tmp0_ = g_strcmp0 (str, "") == 0;
#line 345 "algorithm.c"
	}
#line 85 "../ssh/algorithm.vala"
	if (_tmp0_) {
#line 86 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_UNKNOWN;
#line 86 "../ssh/algorithm.vala"
		return result;
#line 353 "algorithm.c"
	}
#line 88 "../ssh/algorithm.vala"
	_tmp1_ = g_utf8_strdown (str, (gssize) -1);
#line 88 "../ssh/algorithm.vala"
	str_down = _tmp1_;
#line 89 "../ssh/algorithm.vala"
	_tmp2_ = str_down;
#line 89 "../ssh/algorithm.vala"
	if (string_contains (_tmp2_, "rsa")) {
#line 90 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_RSA;
#line 90 "../ssh/algorithm.vala"
		_g_free0 (str_down);
#line 90 "../ssh/algorithm.vala"
		return result;
#line 369 "algorithm.c"
	}
#line 92 "../ssh/algorithm.vala"
	_tmp4_ = str_down;
#line 92 "../ssh/algorithm.vala"
	if (string_contains (_tmp4_, "dsa")) {
#line 92 "../ssh/algorithm.vala"
		_tmp3_ = TRUE;
#line 377 "algorithm.c"
	} else {
		const gchar* _tmp5_;
#line 92 "../ssh/algorithm.vala"
		_tmp5_ = str_down;
#line 92 "../ssh/algorithm.vala"
		_tmp3_ = string_contains (_tmp5_, "dss");
#line 384 "algorithm.c"
	}
#line 92 "../ssh/algorithm.vala"
	if (_tmp3_) {
#line 93 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_DSA;
#line 93 "../ssh/algorithm.vala"
		_g_free0 (str_down);
#line 93 "../ssh/algorithm.vala"
		return result;
#line 394 "algorithm.c"
	}
#line 95 "../ssh/algorithm.vala"
	_tmp6_ = str_down;
#line 95 "../ssh/algorithm.vala"
	if (string_contains (_tmp6_, "ecdsa")) {
#line 96 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_ECDSA;
#line 96 "../ssh/algorithm.vala"
		_g_free0 (str_down);
#line 96 "../ssh/algorithm.vala"
		return result;
#line 406 "algorithm.c"
	}
#line 98 "../ssh/algorithm.vala"
	_tmp7_ = str_down;
#line 98 "../ssh/algorithm.vala"
	if (string_contains (_tmp7_, "ed25519")) {
#line 99 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_ED25519;
#line 99 "../ssh/algorithm.vala"
		_g_free0 (str_down);
#line 99 "../ssh/algorithm.vala"
		return result;
#line 418 "algorithm.c"
	}
#line 101 "../ssh/algorithm.vala"
	result = SEAHORSE_SSH_ALGORITHM_UNKNOWN;
#line 101 "../ssh/algorithm.vala"
	_g_free0 (str_down);
#line 101 "../ssh/algorithm.vala"
	return result;
#line 426 "algorithm.c"
}

/**
 * Enumerates the possible algorithms in which an SSH key can be encrypted.
 * This is also known as the 'type' of a key.
 */
GType
seahorse_ssh_algorithm_get_type (void)
{
	static volatile gsize seahorse_ssh_algorithm_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_ssh_algorithm_type_id__volatile)) {
		static const GEnumValue values[] = {{SEAHORSE_SSH_ALGORITHM_UNKNOWN, "SEAHORSE_SSH_ALGORITHM_UNKNOWN", "unknown"}, {SEAHORSE_SSH_ALGORITHM_RSA, "SEAHORSE_SSH_ALGORITHM_RSA", "rsa"}, {SEAHORSE_SSH_ALGORITHM_DSA, "SEAHORSE_SSH_ALGORITHM_DSA", "dsa"}, {SEAHORSE_SSH_ALGORITHM_ECDSA, "SEAHORSE_SSH_ALGORITHM_ECDSA", "ecdsa"}, {SEAHORSE_SSH_ALGORITHM_ED25519, "SEAHORSE_SSH_ALGORITHM_ED25519", "ed25519"}, {0, NULL, NULL}};
		GType seahorse_ssh_algorithm_type_id;
		seahorse_ssh_algorithm_type_id = g_enum_register_static ("SeahorseSshAlgorithm", values);
		g_once_init_leave (&seahorse_ssh_algorithm_type_id__volatile, seahorse_ssh_algorithm_type_id);
	}
	return seahorse_ssh_algorithm_type_id__volatile;
}

